// *** THIS FILE IS GENERATED - DO NOT EDIT ***
// See vktrace_file_generator.py for modifications


/***************************************************************************
 *
 * Copyright (c) 2015-2017 The Khronos Group Inc.
 * Copyright (c) 2015-2017 Valve Corporation
 * Copyright (c) 2015-2017 LunarG, Inc.
 * Copyright (c) 2015-2017 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Author: Mark Lobodzinski <mark@lunarg.com>
 * Author: Jon Ashburn <jon@lunarg.com>
 * Author: Tobin Ehlis <tobin@lunarg.com>
 * Author: Peter Lohrmann <peterl@valvesoftware.com>
 * Author: David Pinedo <david@lunarg.com>
 *
 ****************************************************************************/


#include "vkreplay_vkreplay.h"
#include "vkreplay.h"
#include "vkreplay_main.h"
#include <algorithm>
#include <queue>

extern "C" {
#include "vktrace_vk_vk_packets.h"
#include "vktrace_vk_packet_id.h"

void vkReplay::init_funcs(void * handle) {
    m_libHandle = handle;
    m_vkFuncs.CreateInstance = (PFN_vkCreateInstance)(vktrace_platform_get_library_entrypoint(handle, "vkCreateInstance"));
    m_vkFuncs.DestroyInstance = (PFN_vkDestroyInstance)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyInstance"));
    m_vkFuncs.EnumeratePhysicalDevices = (PFN_vkEnumeratePhysicalDevices)(vktrace_platform_get_library_entrypoint(handle, "vkEnumeratePhysicalDevices"));
    m_vkFuncs.GetPhysicalDeviceFeatures = (PFN_vkGetPhysicalDeviceFeatures)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceFeatures"));
    m_vkFuncs.GetPhysicalDeviceFormatProperties = (PFN_vkGetPhysicalDeviceFormatProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceFormatProperties"));
    m_vkFuncs.GetPhysicalDeviceImageFormatProperties = (PFN_vkGetPhysicalDeviceImageFormatProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceImageFormatProperties"));
    m_vkFuncs.GetPhysicalDeviceProperties = (PFN_vkGetPhysicalDeviceProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceProperties"));
    m_vkFuncs.GetPhysicalDeviceQueueFamilyProperties = (PFN_vkGetPhysicalDeviceQueueFamilyProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceQueueFamilyProperties"));
    m_vkFuncs.GetPhysicalDeviceMemoryProperties = (PFN_vkGetPhysicalDeviceMemoryProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceMemoryProperties"));
    m_vkFuncs.GetInstanceProcAddr = (PFN_vkGetInstanceProcAddr)(vktrace_platform_get_library_entrypoint(handle, "vkGetInstanceProcAddr"));
    m_vkDeviceFuncs.GetDeviceProcAddr = (PFN_vkGetDeviceProcAddr)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceProcAddr"));
    m_vkFuncs.CreateDevice = (PFN_vkCreateDevice)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDevice"));
    m_vkDeviceFuncs.DestroyDevice = (PFN_vkDestroyDevice)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyDevice"));
    m_vkFuncs.EnumerateInstanceExtensionProperties = (PFN_vkEnumerateInstanceExtensionProperties)(vktrace_platform_get_library_entrypoint(handle, "vkEnumerateInstanceExtensionProperties"));
    m_vkFuncs.EnumerateDeviceExtensionProperties = (PFN_vkEnumerateDeviceExtensionProperties)(vktrace_platform_get_library_entrypoint(handle, "vkEnumerateDeviceExtensionProperties"));
    m_vkFuncs.EnumerateInstanceLayerProperties = (PFN_vkEnumerateInstanceLayerProperties)(vktrace_platform_get_library_entrypoint(handle, "vkEnumerateInstanceLayerProperties"));
    m_vkFuncs.EnumerateDeviceLayerProperties = (PFN_vkEnumerateDeviceLayerProperties)(vktrace_platform_get_library_entrypoint(handle, "vkEnumerateDeviceLayerProperties"));
    m_vkDeviceFuncs.GetDeviceQueue = (PFN_vkGetDeviceQueue)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceQueue"));
    m_vkDeviceFuncs.QueueSubmit = (PFN_vkQueueSubmit)(vktrace_platform_get_library_entrypoint(handle, "vkQueueSubmit"));
    m_vkDeviceFuncs.QueueWaitIdle = (PFN_vkQueueWaitIdle)(vktrace_platform_get_library_entrypoint(handle, "vkQueueWaitIdle"));
    m_vkDeviceFuncs.DeviceWaitIdle = (PFN_vkDeviceWaitIdle)(vktrace_platform_get_library_entrypoint(handle, "vkDeviceWaitIdle"));
    m_vkDeviceFuncs.AllocateMemory = (PFN_vkAllocateMemory)(vktrace_platform_get_library_entrypoint(handle, "vkAllocateMemory"));
    m_vkDeviceFuncs.FreeMemory = (PFN_vkFreeMemory)(vktrace_platform_get_library_entrypoint(handle, "vkFreeMemory"));
    m_vkDeviceFuncs.MapMemory = (PFN_vkMapMemory)(vktrace_platform_get_library_entrypoint(handle, "vkMapMemory"));
    m_vkDeviceFuncs.UnmapMemory = (PFN_vkUnmapMemory)(vktrace_platform_get_library_entrypoint(handle, "vkUnmapMemory"));
    m_vkDeviceFuncs.FlushMappedMemoryRanges = (PFN_vkFlushMappedMemoryRanges)(vktrace_platform_get_library_entrypoint(handle, "vkFlushMappedMemoryRanges"));
    m_vkDeviceFuncs.InvalidateMappedMemoryRanges = (PFN_vkInvalidateMappedMemoryRanges)(vktrace_platform_get_library_entrypoint(handle, "vkInvalidateMappedMemoryRanges"));
    m_vkDeviceFuncs.GetDeviceMemoryCommitment = (PFN_vkGetDeviceMemoryCommitment)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceMemoryCommitment"));
    m_vkDeviceFuncs.BindBufferMemory = (PFN_vkBindBufferMemory)(vktrace_platform_get_library_entrypoint(handle, "vkBindBufferMemory"));
    m_vkDeviceFuncs.BindImageMemory = (PFN_vkBindImageMemory)(vktrace_platform_get_library_entrypoint(handle, "vkBindImageMemory"));
    m_vkDeviceFuncs.GetBufferMemoryRequirements = (PFN_vkGetBufferMemoryRequirements)(vktrace_platform_get_library_entrypoint(handle, "vkGetBufferMemoryRequirements"));
    m_vkDeviceFuncs.GetImageMemoryRequirements = (PFN_vkGetImageMemoryRequirements)(vktrace_platform_get_library_entrypoint(handle, "vkGetImageMemoryRequirements"));
    m_vkDeviceFuncs.GetImageSparseMemoryRequirements = (PFN_vkGetImageSparseMemoryRequirements)(vktrace_platform_get_library_entrypoint(handle, "vkGetImageSparseMemoryRequirements"));
    m_vkFuncs.GetPhysicalDeviceSparseImageFormatProperties = (PFN_vkGetPhysicalDeviceSparseImageFormatProperties)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSparseImageFormatProperties"));
    m_vkDeviceFuncs.QueueBindSparse = (PFN_vkQueueBindSparse)(vktrace_platform_get_library_entrypoint(handle, "vkQueueBindSparse"));
    m_vkDeviceFuncs.CreateFence = (PFN_vkCreateFence)(vktrace_platform_get_library_entrypoint(handle, "vkCreateFence"));
    m_vkDeviceFuncs.DestroyFence = (PFN_vkDestroyFence)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyFence"));
    m_vkDeviceFuncs.ResetFences = (PFN_vkResetFences)(vktrace_platform_get_library_entrypoint(handle, "vkResetFences"));
    m_vkDeviceFuncs.GetFenceStatus = (PFN_vkGetFenceStatus)(vktrace_platform_get_library_entrypoint(handle, "vkGetFenceStatus"));
    m_vkDeviceFuncs.WaitForFences = (PFN_vkWaitForFences)(vktrace_platform_get_library_entrypoint(handle, "vkWaitForFences"));
    m_vkDeviceFuncs.CreateSemaphore = (PFN_vkCreateSemaphore)(vktrace_platform_get_library_entrypoint(handle, "vkCreateSemaphore"));
    m_vkDeviceFuncs.DestroySemaphore = (PFN_vkDestroySemaphore)(vktrace_platform_get_library_entrypoint(handle, "vkDestroySemaphore"));
    m_vkDeviceFuncs.CreateEvent = (PFN_vkCreateEvent)(vktrace_platform_get_library_entrypoint(handle, "vkCreateEvent"));
    m_vkDeviceFuncs.DestroyEvent = (PFN_vkDestroyEvent)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyEvent"));
    m_vkDeviceFuncs.GetEventStatus = (PFN_vkGetEventStatus)(vktrace_platform_get_library_entrypoint(handle, "vkGetEventStatus"));
    m_vkDeviceFuncs.SetEvent = (PFN_vkSetEvent)(vktrace_platform_get_library_entrypoint(handle, "vkSetEvent"));
    m_vkDeviceFuncs.ResetEvent = (PFN_vkResetEvent)(vktrace_platform_get_library_entrypoint(handle, "vkResetEvent"));
    m_vkDeviceFuncs.CreateQueryPool = (PFN_vkCreateQueryPool)(vktrace_platform_get_library_entrypoint(handle, "vkCreateQueryPool"));
    m_vkDeviceFuncs.DestroyQueryPool = (PFN_vkDestroyQueryPool)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyQueryPool"));
    m_vkDeviceFuncs.GetQueryPoolResults = (PFN_vkGetQueryPoolResults)(vktrace_platform_get_library_entrypoint(handle, "vkGetQueryPoolResults"));
    m_vkDeviceFuncs.CreateBuffer = (PFN_vkCreateBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCreateBuffer"));
    m_vkDeviceFuncs.DestroyBuffer = (PFN_vkDestroyBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyBuffer"));
    m_vkDeviceFuncs.CreateBufferView = (PFN_vkCreateBufferView)(vktrace_platform_get_library_entrypoint(handle, "vkCreateBufferView"));
    m_vkDeviceFuncs.DestroyBufferView = (PFN_vkDestroyBufferView)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyBufferView"));
    m_vkDeviceFuncs.CreateImage = (PFN_vkCreateImage)(vktrace_platform_get_library_entrypoint(handle, "vkCreateImage"));
    m_vkDeviceFuncs.DestroyImage = (PFN_vkDestroyImage)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyImage"));
    m_vkDeviceFuncs.GetImageSubresourceLayout = (PFN_vkGetImageSubresourceLayout)(vktrace_platform_get_library_entrypoint(handle, "vkGetImageSubresourceLayout"));
    m_vkDeviceFuncs.CreateImageView = (PFN_vkCreateImageView)(vktrace_platform_get_library_entrypoint(handle, "vkCreateImageView"));
    m_vkDeviceFuncs.DestroyImageView = (PFN_vkDestroyImageView)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyImageView"));
    m_vkDeviceFuncs.CreateShaderModule = (PFN_vkCreateShaderModule)(vktrace_platform_get_library_entrypoint(handle, "vkCreateShaderModule"));
    m_vkDeviceFuncs.DestroyShaderModule = (PFN_vkDestroyShaderModule)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyShaderModule"));
    m_vkDeviceFuncs.CreatePipelineCache = (PFN_vkCreatePipelineCache)(vktrace_platform_get_library_entrypoint(handle, "vkCreatePipelineCache"));
    m_vkDeviceFuncs.DestroyPipelineCache = (PFN_vkDestroyPipelineCache)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyPipelineCache"));
    m_vkDeviceFuncs.GetPipelineCacheData = (PFN_vkGetPipelineCacheData)(vktrace_platform_get_library_entrypoint(handle, "vkGetPipelineCacheData"));
    m_vkDeviceFuncs.MergePipelineCaches = (PFN_vkMergePipelineCaches)(vktrace_platform_get_library_entrypoint(handle, "vkMergePipelineCaches"));
    m_vkDeviceFuncs.CreateGraphicsPipelines = (PFN_vkCreateGraphicsPipelines)(vktrace_platform_get_library_entrypoint(handle, "vkCreateGraphicsPipelines"));
    m_vkDeviceFuncs.CreateComputePipelines = (PFN_vkCreateComputePipelines)(vktrace_platform_get_library_entrypoint(handle, "vkCreateComputePipelines"));
    m_vkDeviceFuncs.DestroyPipeline = (PFN_vkDestroyPipeline)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyPipeline"));
    m_vkDeviceFuncs.CreatePipelineLayout = (PFN_vkCreatePipelineLayout)(vktrace_platform_get_library_entrypoint(handle, "vkCreatePipelineLayout"));
    m_vkDeviceFuncs.DestroyPipelineLayout = (PFN_vkDestroyPipelineLayout)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyPipelineLayout"));
    m_vkDeviceFuncs.CreateSampler = (PFN_vkCreateSampler)(vktrace_platform_get_library_entrypoint(handle, "vkCreateSampler"));
    m_vkDeviceFuncs.DestroySampler = (PFN_vkDestroySampler)(vktrace_platform_get_library_entrypoint(handle, "vkDestroySampler"));
    m_vkDeviceFuncs.CreateDescriptorSetLayout = (PFN_vkCreateDescriptorSetLayout)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDescriptorSetLayout"));
    m_vkDeviceFuncs.DestroyDescriptorSetLayout = (PFN_vkDestroyDescriptorSetLayout)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyDescriptorSetLayout"));
    m_vkDeviceFuncs.CreateDescriptorPool = (PFN_vkCreateDescriptorPool)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDescriptorPool"));
    m_vkDeviceFuncs.DestroyDescriptorPool = (PFN_vkDestroyDescriptorPool)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyDescriptorPool"));
    m_vkDeviceFuncs.ResetDescriptorPool = (PFN_vkResetDescriptorPool)(vktrace_platform_get_library_entrypoint(handle, "vkResetDescriptorPool"));
    m_vkDeviceFuncs.AllocateDescriptorSets = (PFN_vkAllocateDescriptorSets)(vktrace_platform_get_library_entrypoint(handle, "vkAllocateDescriptorSets"));
    m_vkDeviceFuncs.FreeDescriptorSets = (PFN_vkFreeDescriptorSets)(vktrace_platform_get_library_entrypoint(handle, "vkFreeDescriptorSets"));
    m_vkDeviceFuncs.UpdateDescriptorSets = (PFN_vkUpdateDescriptorSets)(vktrace_platform_get_library_entrypoint(handle, "vkUpdateDescriptorSets"));
    m_vkDeviceFuncs.CreateFramebuffer = (PFN_vkCreateFramebuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCreateFramebuffer"));
    m_vkDeviceFuncs.DestroyFramebuffer = (PFN_vkDestroyFramebuffer)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyFramebuffer"));
    m_vkDeviceFuncs.CreateRenderPass = (PFN_vkCreateRenderPass)(vktrace_platform_get_library_entrypoint(handle, "vkCreateRenderPass"));
    m_vkDeviceFuncs.DestroyRenderPass = (PFN_vkDestroyRenderPass)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyRenderPass"));
    m_vkDeviceFuncs.GetRenderAreaGranularity = (PFN_vkGetRenderAreaGranularity)(vktrace_platform_get_library_entrypoint(handle, "vkGetRenderAreaGranularity"));
    m_vkDeviceFuncs.CreateCommandPool = (PFN_vkCreateCommandPool)(vktrace_platform_get_library_entrypoint(handle, "vkCreateCommandPool"));
    m_vkDeviceFuncs.DestroyCommandPool = (PFN_vkDestroyCommandPool)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyCommandPool"));
    m_vkDeviceFuncs.ResetCommandPool = (PFN_vkResetCommandPool)(vktrace_platform_get_library_entrypoint(handle, "vkResetCommandPool"));
    m_vkDeviceFuncs.AllocateCommandBuffers = (PFN_vkAllocateCommandBuffers)(vktrace_platform_get_library_entrypoint(handle, "vkAllocateCommandBuffers"));
    m_vkDeviceFuncs.FreeCommandBuffers = (PFN_vkFreeCommandBuffers)(vktrace_platform_get_library_entrypoint(handle, "vkFreeCommandBuffers"));
    m_vkDeviceFuncs.BeginCommandBuffer = (PFN_vkBeginCommandBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkBeginCommandBuffer"));
    m_vkDeviceFuncs.EndCommandBuffer = (PFN_vkEndCommandBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkEndCommandBuffer"));
    m_vkDeviceFuncs.ResetCommandBuffer = (PFN_vkResetCommandBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkResetCommandBuffer"));
    m_vkDeviceFuncs.CmdBindPipeline = (PFN_vkCmdBindPipeline)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBindPipeline"));
    m_vkDeviceFuncs.CmdSetViewport = (PFN_vkCmdSetViewport)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetViewport"));
    m_vkDeviceFuncs.CmdSetScissor = (PFN_vkCmdSetScissor)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetScissor"));
    m_vkDeviceFuncs.CmdSetLineWidth = (PFN_vkCmdSetLineWidth)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetLineWidth"));
    m_vkDeviceFuncs.CmdSetDepthBias = (PFN_vkCmdSetDepthBias)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetDepthBias"));
    m_vkDeviceFuncs.CmdSetBlendConstants = (PFN_vkCmdSetBlendConstants)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetBlendConstants"));
    m_vkDeviceFuncs.CmdSetDepthBounds = (PFN_vkCmdSetDepthBounds)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetDepthBounds"));
    m_vkDeviceFuncs.CmdSetStencilCompareMask = (PFN_vkCmdSetStencilCompareMask)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetStencilCompareMask"));
    m_vkDeviceFuncs.CmdSetStencilWriteMask = (PFN_vkCmdSetStencilWriteMask)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetStencilWriteMask"));
    m_vkDeviceFuncs.CmdSetStencilReference = (PFN_vkCmdSetStencilReference)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetStencilReference"));
    m_vkDeviceFuncs.CmdBindDescriptorSets = (PFN_vkCmdBindDescriptorSets)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBindDescriptorSets"));
    m_vkDeviceFuncs.CmdBindIndexBuffer = (PFN_vkCmdBindIndexBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBindIndexBuffer"));
    m_vkDeviceFuncs.CmdBindVertexBuffers = (PFN_vkCmdBindVertexBuffers)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBindVertexBuffers"));
    m_vkDeviceFuncs.CmdDraw = (PFN_vkCmdDraw)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDraw"));
    m_vkDeviceFuncs.CmdDrawIndexed = (PFN_vkCmdDrawIndexed)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDrawIndexed"));
    m_vkDeviceFuncs.CmdDrawIndirect = (PFN_vkCmdDrawIndirect)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDrawIndirect"));
    m_vkDeviceFuncs.CmdDrawIndexedIndirect = (PFN_vkCmdDrawIndexedIndirect)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDrawIndexedIndirect"));
    m_vkDeviceFuncs.CmdDispatch = (PFN_vkCmdDispatch)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDispatch"));
    m_vkDeviceFuncs.CmdDispatchIndirect = (PFN_vkCmdDispatchIndirect)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDispatchIndirect"));
    m_vkDeviceFuncs.CmdCopyBuffer = (PFN_vkCmdCopyBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCmdCopyBuffer"));
    m_vkDeviceFuncs.CmdCopyImage = (PFN_vkCmdCopyImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdCopyImage"));
    m_vkDeviceFuncs.CmdBlitImage = (PFN_vkCmdBlitImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBlitImage"));
    m_vkDeviceFuncs.CmdCopyBufferToImage = (PFN_vkCmdCopyBufferToImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdCopyBufferToImage"));
    m_vkDeviceFuncs.CmdCopyImageToBuffer = (PFN_vkCmdCopyImageToBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCmdCopyImageToBuffer"));
    m_vkDeviceFuncs.CmdUpdateBuffer = (PFN_vkCmdUpdateBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCmdUpdateBuffer"));
    m_vkDeviceFuncs.CmdFillBuffer = (PFN_vkCmdFillBuffer)(vktrace_platform_get_library_entrypoint(handle, "vkCmdFillBuffer"));
    m_vkDeviceFuncs.CmdClearColorImage = (PFN_vkCmdClearColorImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdClearColorImage"));
    m_vkDeviceFuncs.CmdClearDepthStencilImage = (PFN_vkCmdClearDepthStencilImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdClearDepthStencilImage"));
    m_vkDeviceFuncs.CmdClearAttachments = (PFN_vkCmdClearAttachments)(vktrace_platform_get_library_entrypoint(handle, "vkCmdClearAttachments"));
    m_vkDeviceFuncs.CmdResolveImage = (PFN_vkCmdResolveImage)(vktrace_platform_get_library_entrypoint(handle, "vkCmdResolveImage"));
    m_vkDeviceFuncs.CmdSetEvent = (PFN_vkCmdSetEvent)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetEvent"));
    m_vkDeviceFuncs.CmdResetEvent = (PFN_vkCmdResetEvent)(vktrace_platform_get_library_entrypoint(handle, "vkCmdResetEvent"));
    m_vkDeviceFuncs.CmdWaitEvents = (PFN_vkCmdWaitEvents)(vktrace_platform_get_library_entrypoint(handle, "vkCmdWaitEvents"));
    m_vkDeviceFuncs.CmdPipelineBarrier = (PFN_vkCmdPipelineBarrier)(vktrace_platform_get_library_entrypoint(handle, "vkCmdPipelineBarrier"));
    m_vkDeviceFuncs.CmdBeginQuery = (PFN_vkCmdBeginQuery)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBeginQuery"));
    m_vkDeviceFuncs.CmdEndQuery = (PFN_vkCmdEndQuery)(vktrace_platform_get_library_entrypoint(handle, "vkCmdEndQuery"));
    m_vkDeviceFuncs.CmdResetQueryPool = (PFN_vkCmdResetQueryPool)(vktrace_platform_get_library_entrypoint(handle, "vkCmdResetQueryPool"));
    m_vkDeviceFuncs.CmdWriteTimestamp = (PFN_vkCmdWriteTimestamp)(vktrace_platform_get_library_entrypoint(handle, "vkCmdWriteTimestamp"));
    m_vkDeviceFuncs.CmdCopyQueryPoolResults = (PFN_vkCmdCopyQueryPoolResults)(vktrace_platform_get_library_entrypoint(handle, "vkCmdCopyQueryPoolResults"));
    m_vkDeviceFuncs.CmdPushConstants = (PFN_vkCmdPushConstants)(vktrace_platform_get_library_entrypoint(handle, "vkCmdPushConstants"));
    m_vkDeviceFuncs.CmdBeginRenderPass = (PFN_vkCmdBeginRenderPass)(vktrace_platform_get_library_entrypoint(handle, "vkCmdBeginRenderPass"));
    m_vkDeviceFuncs.CmdNextSubpass = (PFN_vkCmdNextSubpass)(vktrace_platform_get_library_entrypoint(handle, "vkCmdNextSubpass"));
    m_vkDeviceFuncs.CmdEndRenderPass = (PFN_vkCmdEndRenderPass)(vktrace_platform_get_library_entrypoint(handle, "vkCmdEndRenderPass"));
    m_vkDeviceFuncs.CmdExecuteCommands = (PFN_vkCmdExecuteCommands)(vktrace_platform_get_library_entrypoint(handle, "vkCmdExecuteCommands"));
    m_vkFuncs.DestroySurfaceKHR = (PFN_vkDestroySurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkDestroySurfaceKHR"));
    m_vkFuncs.GetPhysicalDeviceSurfaceSupportKHR = (PFN_vkGetPhysicalDeviceSurfaceSupportKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceSupportKHR"));
    m_vkFuncs.GetPhysicalDeviceSurfaceCapabilitiesKHR = (PFN_vkGetPhysicalDeviceSurfaceCapabilitiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceCapabilitiesKHR"));
    m_vkFuncs.GetPhysicalDeviceSurfaceFormatsKHR = (PFN_vkGetPhysicalDeviceSurfaceFormatsKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceFormatsKHR"));
    m_vkFuncs.GetPhysicalDeviceSurfacePresentModesKHR = (PFN_vkGetPhysicalDeviceSurfacePresentModesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfacePresentModesKHR"));
    m_vkDeviceFuncs.CreateSwapchainKHR = (PFN_vkCreateSwapchainKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateSwapchainKHR"));
    m_vkDeviceFuncs.DestroySwapchainKHR = (PFN_vkDestroySwapchainKHR)(vktrace_platform_get_library_entrypoint(handle, "vkDestroySwapchainKHR"));
    m_vkDeviceFuncs.GetSwapchainImagesKHR = (PFN_vkGetSwapchainImagesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetSwapchainImagesKHR"));
    m_vkDeviceFuncs.AcquireNextImageKHR = (PFN_vkAcquireNextImageKHR)(vktrace_platform_get_library_entrypoint(handle, "vkAcquireNextImageKHR"));
    m_vkDeviceFuncs.QueuePresentKHR = (PFN_vkQueuePresentKHR)(vktrace_platform_get_library_entrypoint(handle, "vkQueuePresentKHR"));
    m_vkFuncs.GetPhysicalDeviceDisplayPropertiesKHR = (PFN_vkGetPhysicalDeviceDisplayPropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceDisplayPropertiesKHR"));
    m_vkFuncs.GetPhysicalDeviceDisplayPlanePropertiesKHR = (PFN_vkGetPhysicalDeviceDisplayPlanePropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceDisplayPlanePropertiesKHR"));
    m_vkFuncs.GetDisplayPlaneSupportedDisplaysKHR = (PFN_vkGetDisplayPlaneSupportedDisplaysKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetDisplayPlaneSupportedDisplaysKHR"));
    m_vkFuncs.GetDisplayModePropertiesKHR = (PFN_vkGetDisplayModePropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetDisplayModePropertiesKHR"));
    m_vkFuncs.CreateDisplayModeKHR = (PFN_vkCreateDisplayModeKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDisplayModeKHR"));
    m_vkFuncs.GetDisplayPlaneCapabilitiesKHR = (PFN_vkGetDisplayPlaneCapabilitiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetDisplayPlaneCapabilitiesKHR"));
    m_vkFuncs.CreateDisplayPlaneSurfaceKHR = (PFN_vkCreateDisplayPlaneSurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDisplayPlaneSurfaceKHR"));
    m_vkDeviceFuncs.CreateSharedSwapchainsKHR = (PFN_vkCreateSharedSwapchainsKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateSharedSwapchainsKHR"));
#ifdef VK_USE_PLATFORM_XLIB_KHR
    m_vkFuncs.CreateXlibSurfaceKHR = (PFN_vkCreateXlibSurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateXlibSurfaceKHR"));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
    m_vkFuncs.GetPhysicalDeviceXlibPresentationSupportKHR = (PFN_vkGetPhysicalDeviceXlibPresentationSupportKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceXlibPresentationSupportKHR"));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    m_vkFuncs.CreateXcbSurfaceKHR = (PFN_vkCreateXcbSurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateXcbSurfaceKHR"));
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    m_vkFuncs.GetPhysicalDeviceXcbPresentationSupportKHR = (PFN_vkGetPhysicalDeviceXcbPresentationSupportKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceXcbPresentationSupportKHR"));
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    m_vkFuncs.CreateWaylandSurfaceKHR = (PFN_vkCreateWaylandSurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateWaylandSurfaceKHR"));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    m_vkFuncs.GetPhysicalDeviceWaylandPresentationSupportKHR = (PFN_vkGetPhysicalDeviceWaylandPresentationSupportKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceWaylandPresentationSupportKHR"));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    m_vkFuncs.CreateAndroidSurfaceKHR = (PFN_vkCreateAndroidSurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateAndroidSurfaceKHR"));
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkFuncs.CreateWin32SurfaceKHR = (PFN_vkCreateWin32SurfaceKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateWin32SurfaceKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkFuncs.GetPhysicalDeviceWin32PresentationSupportKHR = (PFN_vkGetPhysicalDeviceWin32PresentationSupportKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceWin32PresentationSupportKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
    m_vkFuncs.GetPhysicalDeviceFeatures2KHR = (PFN_vkGetPhysicalDeviceFeatures2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceFeatures2KHR"));
    m_vkFuncs.GetPhysicalDeviceProperties2KHR = (PFN_vkGetPhysicalDeviceProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceProperties2KHR"));
    m_vkFuncs.GetPhysicalDeviceFormatProperties2KHR = (PFN_vkGetPhysicalDeviceFormatProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceFormatProperties2KHR"));
    m_vkFuncs.GetPhysicalDeviceImageFormatProperties2KHR = (PFN_vkGetPhysicalDeviceImageFormatProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceImageFormatProperties2KHR"));
    m_vkFuncs.GetPhysicalDeviceQueueFamilyProperties2KHR = (PFN_vkGetPhysicalDeviceQueueFamilyProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceQueueFamilyProperties2KHR"));
    m_vkFuncs.GetPhysicalDeviceMemoryProperties2KHR = (PFN_vkGetPhysicalDeviceMemoryProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceMemoryProperties2KHR"));
    m_vkFuncs.GetPhysicalDeviceSparseImageFormatProperties2KHR = (PFN_vkGetPhysicalDeviceSparseImageFormatProperties2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSparseImageFormatProperties2KHR"));
    m_vkDeviceFuncs.TrimCommandPoolKHR = (PFN_vkTrimCommandPoolKHR)(vktrace_platform_get_library_entrypoint(handle, "vkTrimCommandPoolKHR"));
    m_vkFuncs.GetPhysicalDeviceExternalBufferPropertiesKHR = (PFN_vkGetPhysicalDeviceExternalBufferPropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceExternalBufferPropertiesKHR"));
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetMemoryWin32HandleKHR = (PFN_vkGetMemoryWin32HandleKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryWin32HandleKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetMemoryWin32HandlePropertiesKHR = (PFN_vkGetMemoryWin32HandlePropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryWin32HandlePropertiesKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetMemoryFdKHR = (PFN_vkGetMemoryFdKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryFdKHR"));
    m_vkDeviceFuncs.GetMemoryFdPropertiesKHR = (PFN_vkGetMemoryFdPropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryFdPropertiesKHR"));
    m_vkFuncs.GetPhysicalDeviceExternalSemaphorePropertiesKHR = (PFN_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceExternalSemaphorePropertiesKHR"));
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.ImportSemaphoreWin32HandleKHR = (PFN_vkImportSemaphoreWin32HandleKHR)(vktrace_platform_get_library_entrypoint(handle, "vkImportSemaphoreWin32HandleKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetSemaphoreWin32HandleKHR = (PFN_vkGetSemaphoreWin32HandleKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetSemaphoreWin32HandleKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.ImportSemaphoreFdKHR = (PFN_vkImportSemaphoreFdKHR)(vktrace_platform_get_library_entrypoint(handle, "vkImportSemaphoreFdKHR"));
    m_vkDeviceFuncs.GetSemaphoreFdKHR = (PFN_vkGetSemaphoreFdKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetSemaphoreFdKHR"));
    m_vkDeviceFuncs.CmdPushDescriptorSetKHR = (PFN_vkCmdPushDescriptorSetKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCmdPushDescriptorSetKHR"));
    m_vkDeviceFuncs.CreateDescriptorUpdateTemplateKHR = (PFN_vkCreateDescriptorUpdateTemplateKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateDescriptorUpdateTemplateKHR"));
    m_vkDeviceFuncs.DestroyDescriptorUpdateTemplateKHR = (PFN_vkDestroyDescriptorUpdateTemplateKHR)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyDescriptorUpdateTemplateKHR"));
    m_vkDeviceFuncs.UpdateDescriptorSetWithTemplateKHR = (PFN_vkUpdateDescriptorSetWithTemplateKHR)(vktrace_platform_get_library_entrypoint(handle, "vkUpdateDescriptorSetWithTemplateKHR"));
    m_vkDeviceFuncs.CmdPushDescriptorSetWithTemplateKHR = (PFN_vkCmdPushDescriptorSetWithTemplateKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCmdPushDescriptorSetWithTemplateKHR"));
    m_vkDeviceFuncs.GetSwapchainStatusKHR = (PFN_vkGetSwapchainStatusKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetSwapchainStatusKHR"));
    m_vkFuncs.GetPhysicalDeviceExternalFencePropertiesKHR = (PFN_vkGetPhysicalDeviceExternalFencePropertiesKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceExternalFencePropertiesKHR"));
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.ImportFenceWin32HandleKHR = (PFN_vkImportFenceWin32HandleKHR)(vktrace_platform_get_library_entrypoint(handle, "vkImportFenceWin32HandleKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetFenceWin32HandleKHR = (PFN_vkGetFenceWin32HandleKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetFenceWin32HandleKHR"));
#endif // VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.ImportFenceFdKHR = (PFN_vkImportFenceFdKHR)(vktrace_platform_get_library_entrypoint(handle, "vkImportFenceFdKHR"));
    m_vkDeviceFuncs.GetFenceFdKHR = (PFN_vkGetFenceFdKHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetFenceFdKHR"));
    m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2KHR = (PFN_vkGetPhysicalDeviceSurfaceCapabilities2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceCapabilities2KHR"));
    m_vkFuncs.GetPhysicalDeviceSurfaceFormats2KHR = (PFN_vkGetPhysicalDeviceSurfaceFormats2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceFormats2KHR"));
    m_vkDeviceFuncs.GetImageMemoryRequirements2KHR = (PFN_vkGetImageMemoryRequirements2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetImageMemoryRequirements2KHR"));
    m_vkDeviceFuncs.GetBufferMemoryRequirements2KHR = (PFN_vkGetBufferMemoryRequirements2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetBufferMemoryRequirements2KHR"));
    m_vkDeviceFuncs.GetImageSparseMemoryRequirements2KHR = (PFN_vkGetImageSparseMemoryRequirements2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkGetImageSparseMemoryRequirements2KHR"));
    m_vkDeviceFuncs.CreateSamplerYcbcrConversionKHR = (PFN_vkCreateSamplerYcbcrConversionKHR)(vktrace_platform_get_library_entrypoint(handle, "vkCreateSamplerYcbcrConversionKHR"));
    m_vkDeviceFuncs.DestroySamplerYcbcrConversionKHR = (PFN_vkDestroySamplerYcbcrConversionKHR)(vktrace_platform_get_library_entrypoint(handle, "vkDestroySamplerYcbcrConversionKHR"));
    m_vkDeviceFuncs.BindBufferMemory2KHR = (PFN_vkBindBufferMemory2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkBindBufferMemory2KHR"));
    m_vkDeviceFuncs.BindImageMemory2KHR = (PFN_vkBindImageMemory2KHR)(vktrace_platform_get_library_entrypoint(handle, "vkBindImageMemory2KHR"));
    m_vkFuncs.CreateDebugReportCallbackEXT = (PFN_vkCreateDebugReportCallbackEXT)NULL;
    m_vkFuncs.DestroyDebugReportCallbackEXT = (PFN_vkDestroyDebugReportCallbackEXT)NULL;
    m_vkFuncs.DebugReportMessageEXT = (PFN_vkDebugReportMessageEXT)NULL;
    m_vkDeviceFuncs.DebugMarkerSetObjectTagEXT = (PFN_vkDebugMarkerSetObjectTagEXT)(vktrace_platform_get_library_entrypoint(handle, "vkDebugMarkerSetObjectTagEXT"));
    m_vkDeviceFuncs.DebugMarkerSetObjectNameEXT = (PFN_vkDebugMarkerSetObjectNameEXT)(vktrace_platform_get_library_entrypoint(handle, "vkDebugMarkerSetObjectNameEXT"));
    m_vkDeviceFuncs.CmdDebugMarkerBeginEXT = (PFN_vkCmdDebugMarkerBeginEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDebugMarkerBeginEXT"));
    m_vkDeviceFuncs.CmdDebugMarkerEndEXT = (PFN_vkCmdDebugMarkerEndEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDebugMarkerEndEXT"));
    m_vkDeviceFuncs.CmdDebugMarkerInsertEXT = (PFN_vkCmdDebugMarkerInsertEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDebugMarkerInsertEXT"));
    m_vkDeviceFuncs.CmdDrawIndirectCountAMD = (PFN_vkCmdDrawIndirectCountAMD)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDrawIndirectCountAMD"));
    m_vkDeviceFuncs.CmdDrawIndexedIndirectCountAMD = (PFN_vkCmdDrawIndexedIndirectCountAMD)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDrawIndexedIndirectCountAMD"));
    m_vkDeviceFuncs.GetShaderInfoAMD = (PFN_vkGetShaderInfoAMD)(vktrace_platform_get_library_entrypoint(handle, "vkGetShaderInfoAMD"));
    m_vkFuncs.GetPhysicalDeviceExternalImageFormatPropertiesNV = (PFN_vkGetPhysicalDeviceExternalImageFormatPropertiesNV)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceExternalImageFormatPropertiesNV"));
#ifdef VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetMemoryWin32HandleNV = (PFN_vkGetMemoryWin32HandleNV)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryWin32HandleNV"));
#endif // VK_USE_PLATFORM_WIN32_KHR
    m_vkDeviceFuncs.GetDeviceGroupPeerMemoryFeaturesKHX = (PFN_vkGetDeviceGroupPeerMemoryFeaturesKHX)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceGroupPeerMemoryFeaturesKHX"));
    m_vkDeviceFuncs.CmdSetDeviceMaskKHX = (PFN_vkCmdSetDeviceMaskKHX)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetDeviceMaskKHX"));
    m_vkDeviceFuncs.CmdDispatchBaseKHX = (PFN_vkCmdDispatchBaseKHX)(vktrace_platform_get_library_entrypoint(handle, "vkCmdDispatchBaseKHX"));
    m_vkDeviceFuncs.GetDeviceGroupPresentCapabilitiesKHX = (PFN_vkGetDeviceGroupPresentCapabilitiesKHX)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceGroupPresentCapabilitiesKHX"));
    m_vkDeviceFuncs.GetDeviceGroupSurfacePresentModesKHX = (PFN_vkGetDeviceGroupSurfacePresentModesKHX)(vktrace_platform_get_library_entrypoint(handle, "vkGetDeviceGroupSurfacePresentModesKHX"));
    m_vkFuncs.GetPhysicalDevicePresentRectanglesKHX = (PFN_vkGetPhysicalDevicePresentRectanglesKHX)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDevicePresentRectanglesKHX"));
    m_vkDeviceFuncs.AcquireNextImage2KHX = (PFN_vkAcquireNextImage2KHX)(vktrace_platform_get_library_entrypoint(handle, "vkAcquireNextImage2KHX"));
    m_vkFuncs.EnumeratePhysicalDeviceGroupsKHX = (PFN_vkEnumeratePhysicalDeviceGroupsKHX)(vktrace_platform_get_library_entrypoint(handle, "vkEnumeratePhysicalDeviceGroupsKHX"));
    m_vkDeviceFuncs.CmdProcessCommandsNVX = (PFN_vkCmdProcessCommandsNVX)(vktrace_platform_get_library_entrypoint(handle, "vkCmdProcessCommandsNVX"));
    m_vkDeviceFuncs.CmdReserveSpaceForCommandsNVX = (PFN_vkCmdReserveSpaceForCommandsNVX)(vktrace_platform_get_library_entrypoint(handle, "vkCmdReserveSpaceForCommandsNVX"));
    m_vkDeviceFuncs.CreateIndirectCommandsLayoutNVX = (PFN_vkCreateIndirectCommandsLayoutNVX)(vktrace_platform_get_library_entrypoint(handle, "vkCreateIndirectCommandsLayoutNVX"));
    m_vkDeviceFuncs.DestroyIndirectCommandsLayoutNVX = (PFN_vkDestroyIndirectCommandsLayoutNVX)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyIndirectCommandsLayoutNVX"));
    m_vkDeviceFuncs.CreateObjectTableNVX = (PFN_vkCreateObjectTableNVX)(vktrace_platform_get_library_entrypoint(handle, "vkCreateObjectTableNVX"));
    m_vkDeviceFuncs.DestroyObjectTableNVX = (PFN_vkDestroyObjectTableNVX)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyObjectTableNVX"));
    m_vkDeviceFuncs.RegisterObjectsNVX = (PFN_vkRegisterObjectsNVX)(vktrace_platform_get_library_entrypoint(handle, "vkRegisterObjectsNVX"));
    m_vkDeviceFuncs.UnregisterObjectsNVX = (PFN_vkUnregisterObjectsNVX)(vktrace_platform_get_library_entrypoint(handle, "vkUnregisterObjectsNVX"));
    m_vkFuncs.GetPhysicalDeviceGeneratedCommandsPropertiesNVX = (PFN_vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX"));
    m_vkDeviceFuncs.CmdSetViewportWScalingNV = (PFN_vkCmdSetViewportWScalingNV)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetViewportWScalingNV"));
    m_vkFuncs.ReleaseDisplayEXT = (PFN_vkReleaseDisplayEXT)(vktrace_platform_get_library_entrypoint(handle, "vkReleaseDisplayEXT"));
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    m_vkFuncs.AcquireXlibDisplayEXT = (PFN_vkAcquireXlibDisplayEXT)(vktrace_platform_get_library_entrypoint(handle, "vkAcquireXlibDisplayEXT"));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    m_vkFuncs.GetRandROutputDisplayEXT = (PFN_vkGetRandROutputDisplayEXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetRandROutputDisplayEXT"));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
    m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2EXT = (PFN_vkGetPhysicalDeviceSurfaceCapabilities2EXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceSurfaceCapabilities2EXT"));
    m_vkDeviceFuncs.DisplayPowerControlEXT = (PFN_vkDisplayPowerControlEXT)(vktrace_platform_get_library_entrypoint(handle, "vkDisplayPowerControlEXT"));
    m_vkDeviceFuncs.RegisterDeviceEventEXT = (PFN_vkRegisterDeviceEventEXT)(vktrace_platform_get_library_entrypoint(handle, "vkRegisterDeviceEventEXT"));
    m_vkDeviceFuncs.RegisterDisplayEventEXT = (PFN_vkRegisterDisplayEventEXT)(vktrace_platform_get_library_entrypoint(handle, "vkRegisterDisplayEventEXT"));
    m_vkDeviceFuncs.GetSwapchainCounterEXT = (PFN_vkGetSwapchainCounterEXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetSwapchainCounterEXT"));
    m_vkDeviceFuncs.GetRefreshCycleDurationGOOGLE = (PFN_vkGetRefreshCycleDurationGOOGLE)(vktrace_platform_get_library_entrypoint(handle, "vkGetRefreshCycleDurationGOOGLE"));
    m_vkDeviceFuncs.GetPastPresentationTimingGOOGLE = (PFN_vkGetPastPresentationTimingGOOGLE)(vktrace_platform_get_library_entrypoint(handle, "vkGetPastPresentationTimingGOOGLE"));
    m_vkDeviceFuncs.CmdSetDiscardRectangleEXT = (PFN_vkCmdSetDiscardRectangleEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetDiscardRectangleEXT"));
    m_vkDeviceFuncs.SetHdrMetadataEXT = (PFN_vkSetHdrMetadataEXT)(vktrace_platform_get_library_entrypoint(handle, "vkSetHdrMetadataEXT"));
    m_vkDeviceFuncs.CmdSetSampleLocationsEXT = (PFN_vkCmdSetSampleLocationsEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCmdSetSampleLocationsEXT"));
    m_vkFuncs.GetPhysicalDeviceMultisamplePropertiesEXT = (PFN_vkGetPhysicalDeviceMultisamplePropertiesEXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetPhysicalDeviceMultisamplePropertiesEXT"));
    m_vkDeviceFuncs.CreateValidationCacheEXT = (PFN_vkCreateValidationCacheEXT)(vktrace_platform_get_library_entrypoint(handle, "vkCreateValidationCacheEXT"));
    m_vkDeviceFuncs.DestroyValidationCacheEXT = (PFN_vkDestroyValidationCacheEXT)(vktrace_platform_get_library_entrypoint(handle, "vkDestroyValidationCacheEXT"));
    m_vkDeviceFuncs.MergeValidationCachesEXT = (PFN_vkMergeValidationCachesEXT)(vktrace_platform_get_library_entrypoint(handle, "vkMergeValidationCachesEXT"));
    m_vkDeviceFuncs.GetValidationCacheDataEXT = (PFN_vkGetValidationCacheDataEXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetValidationCacheDataEXT"));
    m_vkDeviceFuncs.GetMemoryHostPointerPropertiesEXT = (PFN_vkGetMemoryHostPointerPropertiesEXT)(vktrace_platform_get_library_entrypoint(handle, "vkGetMemoryHostPointerPropertiesEXT"));
}

vktrace_replay::VKTRACE_REPLAY_RESULT vkReplay::replay(vktrace_trace_packet_header *packet) { 
    vktrace_replay::VKTRACE_REPLAY_RESULT returnValue = vktrace_replay::VKTRACE_REPLAY_SUCCESS;
    VkResult replayResult = VK_ERROR_VALIDATION_FAILED_EXT;
    switch (packet->packet_id) {
        case VKTRACE_TPI_VK_vkApiVersion: {
            packet_vkApiVersion* pPacket = (packet_vkApiVersion*)(packet->pBody);
            if (VK_VERSION_MAJOR(pPacket->version) != 1 || VK_VERSION_MINOR (pPacket->version) != 0) {
                vktrace_LogError("Trace file is from Vulkan version 0x%x (%u.%u.%u), but the vktrace plugin only supports version 0x%x (%u.%u.%u).", pPacket->version, (pPacket->version & 0xFFC00000) >> 22, (pPacket->version & 0x003FF000) >> 12, (pPacket->version & 0x00000FFF), VK_MAKE_VERSION(1, 0, VK_HEADER_VERSION), ((VK_MAKE_VERSION(1, 0, VK_HEADER_VERSION)) & 0xFFC00000) >> 22, ((VK_MAKE_VERSION(1, 0, VK_HEADER_VERSION)) & 0x003FF000) >> 12, ((VK_MAKE_VERSION(1, 0, VK_HEADER_VERSION)) & 0x00000FFF));
                returnValue = vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            break;
        }
        case VKTRACE_TPI_VK_vkCreateInstance: { 
            packet_vkCreateInstance* pPacket = (packet_vkCreateInstance*)(packet->pBody);
            replayResult = manually_replay_vkCreateInstance(pPacket);
            CHECK_RETURN_VALUE(vkCreateInstance);
            if (replayResult == VK_SUCCESS) {
                VkInstance remappedInstance = m_objMapper.remap_instances(*pPacket->pInstance);
                if (remappedInstance == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in vkCreateInstance() due to invalid remapped VkInstance.");
                    returnValue = vktrace_replay::VKTRACE_REPLAY_ERROR;
                    break;
                }
                VkFlags reportFlags = VK_DEBUG_REPORT_INFORMATION_BIT_EXT | VK_DEBUG_REPORT_WARNING_BIT_EXT | VK_DEBUG_REPORT_PERFORMANCE_WARNING_BIT_EXT | VK_DEBUG_REPORT_ERROR_BIT_EXT | VK_DEBUG_REPORT_DEBUG_BIT_EXT;
                PFN_vkCreateDebugReportCallbackEXT callback = (PFN_vkCreateDebugReportCallbackEXT)vkGetInstanceProcAddr(remappedInstance, "vkCreateDebugReportCallbackEXT");
                if (callback != NULL) {
                    VkDebugReportCallbackCreateInfoEXT dbgCreateInfo;
                    memset(&dbgCreateInfo, 0, sizeof(dbgCreateInfo));
                    dbgCreateInfo.sType = VK_STRUCTURE_TYPE_DEBUG_REPORT_CREATE_INFO_EXT;
                    dbgCreateInfo.flags = reportFlags;
                    dbgCreateInfo.pfnCallback = g_fpDbgMsgCallback;
                    dbgCreateInfo.pUserData = NULL;
                    if (callback(remappedInstance, &dbgCreateInfo, NULL, &m_dbgMsgCallbackObj) != VK_SUCCESS) {
                        vktrace_LogWarning("Failed to register vulkan callback for replayer error handling.");
                        returnValue = vktrace_replay::VKTRACE_REPLAY_ERROR;
                        break;
                    }
                }
            }            break;
        }
        case VKTRACE_TPI_VK_vkDestroyInstance: { 
            packet_vkDestroyInstance* pPacket = (packet_vkDestroyInstance*)(packet->pBody);
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyInstance() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            if (m_vkFuncs.DestroyDebugReportCallbackEXT != NULL) {
                m_vkFuncs.DestroyDebugReportCallbackEXT(remappedinstance, m_dbgMsgCallbackObj, pPacket->pAllocator);
            }
            m_vkFuncs.DestroyInstance(remappedinstance, pPacket->pAllocator);
            if (replayResult == VK_SUCCESS) {
                // TODO need to handle multiple instances and only clearing maps within an instance.
                // TODO this only works with a single instance used at any given time.
                m_objMapper.clear_all_map_handles();
            }
            break;
        }
        case VKTRACE_TPI_VK_vkEnumeratePhysicalDevices: { 
            packet_vkEnumeratePhysicalDevices* pPacket = (packet_vkEnumeratePhysicalDevices*)(packet->pBody);
            replayResult = manually_replay_vkEnumeratePhysicalDevices(pPacket);
            CHECK_RETURN_VALUE(vkEnumeratePhysicalDevices);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceFeatures: { 
            packet_vkGetPhysicalDeviceFeatures* pPacket = (packet_vkGetPhysicalDeviceFeatures*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceFeatures() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pFeatures
            m_vkFuncs.GetPhysicalDeviceFeatures(remappedphysicalDevice, pPacket->pFeatures);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceFormatProperties: { 
            packet_vkGetPhysicalDeviceFormatProperties* pPacket = (packet_vkGetPhysicalDeviceFormatProperties*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceFormatProperties() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap format
            // No need to remap pFormatProperties
            m_vkFuncs.GetPhysicalDeviceFormatProperties(remappedphysicalDevice, pPacket->format, pPacket->pFormatProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceImageFormatProperties: { 
            packet_vkGetPhysicalDeviceImageFormatProperties* pPacket = (packet_vkGetPhysicalDeviceImageFormatProperties*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceImageFormatProperties() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap format
            // No need to remap type
            // No need to remap tiling
            // No need to remap usage
            // No need to remap flags
            // No need to remap pImageFormatProperties
            replayResult = m_vkFuncs.GetPhysicalDeviceImageFormatProperties(remappedphysicalDevice, pPacket->format, pPacket->type, pPacket->tiling, pPacket->usage, pPacket->flags, pPacket->pImageFormatProperties);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceImageFormatProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceProperties: { 
            packet_vkGetPhysicalDeviceProperties* pPacket = (packet_vkGetPhysicalDeviceProperties*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceProperties(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceQueueFamilyProperties: { 
            packet_vkGetPhysicalDeviceQueueFamilyProperties* pPacket = (packet_vkGetPhysicalDeviceQueueFamilyProperties*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceQueueFamilyProperties(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceMemoryProperties: { 
            packet_vkGetPhysicalDeviceMemoryProperties* pPacket = (packet_vkGetPhysicalDeviceMemoryProperties*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceMemoryProperties(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetInstanceProcAddr: { 
            packet_vkGetInstanceProcAddr* pPacket = (packet_vkGetInstanceProcAddr*)(packet->pBody);
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetInstanceProcAddr() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pName
            if (strcmp(pPacket->pName, "vkDestroySurfaceKHR") == 0) {
               m_vkFuncs.DestroySurfaceKHR = (PFN_vkDestroySurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceSupportKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceSupportKHR = (PFN_vkGetPhysicalDeviceSurfaceSupportKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceCapabilitiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceCapabilitiesKHR = (PFN_vkGetPhysicalDeviceSurfaceCapabilitiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceFormatsKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceFormatsKHR = (PFN_vkGetPhysicalDeviceSurfaceFormatsKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfacePresentModesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfacePresentModesKHR = (PFN_vkGetPhysicalDeviceSurfacePresentModesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceDisplayPropertiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceDisplayPropertiesKHR = (PFN_vkGetPhysicalDeviceDisplayPropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceDisplayPlanePropertiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceDisplayPlanePropertiesKHR = (PFN_vkGetPhysicalDeviceDisplayPlanePropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetDisplayPlaneSupportedDisplaysKHR") == 0) {
               m_vkFuncs.GetDisplayPlaneSupportedDisplaysKHR = (PFN_vkGetDisplayPlaneSupportedDisplaysKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetDisplayModePropertiesKHR") == 0) {
               m_vkFuncs.GetDisplayModePropertiesKHR = (PFN_vkGetDisplayModePropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateDisplayModeKHR") == 0) {
               m_vkFuncs.CreateDisplayModeKHR = (PFN_vkCreateDisplayModeKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetDisplayPlaneCapabilitiesKHR") == 0) {
               m_vkFuncs.GetDisplayPlaneCapabilitiesKHR = (PFN_vkGetDisplayPlaneCapabilitiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateDisplayPlaneSurfaceKHR") == 0) {
               m_vkFuncs.CreateDisplayPlaneSurfaceKHR = (PFN_vkCreateDisplayPlaneSurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_XLIB_KHR
            if (strcmp(pPacket->pName, "vkCreateXlibSurfaceKHR") == 0) {
               m_vkFuncs.CreateXlibSurfaceKHR = (PFN_vkCreateXlibSurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceXlibPresentationSupportKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceXlibPresentationSupportKHR = (PFN_vkGetPhysicalDeviceXlibPresentationSupportKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
            if (strcmp(pPacket->pName, "vkCreateXcbSurfaceKHR") == 0) {
               m_vkFuncs.CreateXcbSurfaceKHR = (PFN_vkCreateXcbSurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceXcbPresentationSupportKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceXcbPresentationSupportKHR = (PFN_vkGetPhysicalDeviceXcbPresentationSupportKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
            if (strcmp(pPacket->pName, "vkCreateWaylandSurfaceKHR") == 0) {
               m_vkFuncs.CreateWaylandSurfaceKHR = (PFN_vkCreateWaylandSurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceWaylandPresentationSupportKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceWaylandPresentationSupportKHR = (PFN_vkGetPhysicalDeviceWaylandPresentationSupportKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
            if (strcmp(pPacket->pName, "vkCreateAndroidSurfaceKHR") == 0) {
               m_vkFuncs.CreateAndroidSurfaceKHR = (PFN_vkCreateAndroidSurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkCreateWin32SurfaceKHR") == 0) {
               m_vkFuncs.CreateWin32SurfaceKHR = (PFN_vkCreateWin32SurfaceKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceWin32PresentationSupportKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceWin32PresentationSupportKHR = (PFN_vkGetPhysicalDeviceWin32PresentationSupportKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceFeatures2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceFeatures2KHR = (PFN_vkGetPhysicalDeviceFeatures2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceProperties2KHR = (PFN_vkGetPhysicalDeviceProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceFormatProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceFormatProperties2KHR = (PFN_vkGetPhysicalDeviceFormatProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceImageFormatProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceImageFormatProperties2KHR = (PFN_vkGetPhysicalDeviceImageFormatProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceQueueFamilyProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceQueueFamilyProperties2KHR = (PFN_vkGetPhysicalDeviceQueueFamilyProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceMemoryProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceMemoryProperties2KHR = (PFN_vkGetPhysicalDeviceMemoryProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSparseImageFormatProperties2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSparseImageFormatProperties2KHR = (PFN_vkGetPhysicalDeviceSparseImageFormatProperties2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceExternalBufferPropertiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceExternalBufferPropertiesKHR = (PFN_vkGetPhysicalDeviceExternalBufferPropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceExternalSemaphorePropertiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceExternalSemaphorePropertiesKHR = (PFN_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceExternalFencePropertiesKHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceExternalFencePropertiesKHR = (PFN_vkGetPhysicalDeviceExternalFencePropertiesKHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceCapabilities2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2KHR = (PFN_vkGetPhysicalDeviceSurfaceCapabilities2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceFormats2KHR") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceFormats2KHR = (PFN_vkGetPhysicalDeviceSurfaceFormats2KHR)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateDebugReportCallbackEXT") == 0) {
               m_vkFuncs.CreateDebugReportCallbackEXT = (PFN_vkCreateDebugReportCallbackEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroyDebugReportCallbackEXT") == 0) {
               m_vkFuncs.DestroyDebugReportCallbackEXT = (PFN_vkDestroyDebugReportCallbackEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDebugReportMessageEXT") == 0) {
               m_vkFuncs.DebugReportMessageEXT = (PFN_vkDebugReportMessageEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceExternalImageFormatPropertiesNV") == 0) {
               m_vkFuncs.GetPhysicalDeviceExternalImageFormatPropertiesNV = (PFN_vkGetPhysicalDeviceExternalImageFormatPropertiesNV)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDevicePresentRectanglesKHX") == 0) {
               m_vkFuncs.GetPhysicalDevicePresentRectanglesKHX = (PFN_vkGetPhysicalDevicePresentRectanglesKHX)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkEnumeratePhysicalDeviceGroupsKHX") == 0) {
               m_vkFuncs.EnumeratePhysicalDeviceGroupsKHX = (PFN_vkEnumeratePhysicalDeviceGroupsKHX)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX") == 0) {
               m_vkFuncs.GetPhysicalDeviceGeneratedCommandsPropertiesNVX = (PFN_vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkReleaseDisplayEXT") == 0) {
               m_vkFuncs.ReleaseDisplayEXT = (PFN_vkReleaseDisplayEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
            if (strcmp(pPacket->pName, "vkAcquireXlibDisplayEXT") == 0) {
               m_vkFuncs.AcquireXlibDisplayEXT = (PFN_vkAcquireXlibDisplayEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
            if (strcmp(pPacket->pName, "vkGetRandROutputDisplayEXT") == 0) {
               m_vkFuncs.GetRandROutputDisplayEXT = (PFN_vkGetRandROutputDisplayEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceSurfaceCapabilities2EXT") == 0) {
               m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2EXT = (PFN_vkGetPhysicalDeviceSurfaceCapabilities2EXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPhysicalDeviceMultisamplePropertiesEXT") == 0) {
               m_vkFuncs.GetPhysicalDeviceMultisamplePropertiesEXT = (PFN_vkGetPhysicalDeviceMultisamplePropertiesEXT)vkGetInstanceProcAddr(remappedinstance, pPacket->pName);
            }
            m_vkFuncs.GetInstanceProcAddr(remappedinstance, pPacket->pName);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDeviceProcAddr: { 
            packet_vkGetDeviceProcAddr* pPacket = (packet_vkGetDeviceProcAddr*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceProcAddr() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pName
            if (strcmp(pPacket->pName, "vkCreateSwapchainKHR") == 0) {
               m_vkDeviceFuncs.CreateSwapchainKHR = (PFN_vkCreateSwapchainKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroySwapchainKHR") == 0) {
               m_vkDeviceFuncs.DestroySwapchainKHR = (PFN_vkDestroySwapchainKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetSwapchainImagesKHR") == 0) {
               m_vkDeviceFuncs.GetSwapchainImagesKHR = (PFN_vkGetSwapchainImagesKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkAcquireNextImageKHR") == 0) {
               m_vkDeviceFuncs.AcquireNextImageKHR = (PFN_vkAcquireNextImageKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkQueuePresentKHR") == 0) {
               m_vkDeviceFuncs.QueuePresentKHR = (PFN_vkQueuePresentKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateSharedSwapchainsKHR") == 0) {
               m_vkDeviceFuncs.CreateSharedSwapchainsKHR = (PFN_vkCreateSharedSwapchainsKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkTrimCommandPoolKHR") == 0) {
               m_vkDeviceFuncs.TrimCommandPoolKHR = (PFN_vkTrimCommandPoolKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetMemoryWin32HandleKHR") == 0) {
               m_vkDeviceFuncs.GetMemoryWin32HandleKHR = (PFN_vkGetMemoryWin32HandleKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetMemoryWin32HandlePropertiesKHR") == 0) {
               m_vkDeviceFuncs.GetMemoryWin32HandlePropertiesKHR = (PFN_vkGetMemoryWin32HandlePropertiesKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetMemoryFdKHR") == 0) {
               m_vkDeviceFuncs.GetMemoryFdKHR = (PFN_vkGetMemoryFdKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetMemoryFdPropertiesKHR") == 0) {
               m_vkDeviceFuncs.GetMemoryFdPropertiesKHR = (PFN_vkGetMemoryFdPropertiesKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkImportSemaphoreWin32HandleKHR") == 0) {
               m_vkDeviceFuncs.ImportSemaphoreWin32HandleKHR = (PFN_vkImportSemaphoreWin32HandleKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetSemaphoreWin32HandleKHR") == 0) {
               m_vkDeviceFuncs.GetSemaphoreWin32HandleKHR = (PFN_vkGetSemaphoreWin32HandleKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkImportSemaphoreFdKHR") == 0) {
               m_vkDeviceFuncs.ImportSemaphoreFdKHR = (PFN_vkImportSemaphoreFdKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetSemaphoreFdKHR") == 0) {
               m_vkDeviceFuncs.GetSemaphoreFdKHR = (PFN_vkGetSemaphoreFdKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdPushDescriptorSetKHR") == 0) {
               m_vkDeviceFuncs.CmdPushDescriptorSetKHR = (PFN_vkCmdPushDescriptorSetKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateDescriptorUpdateTemplateKHR") == 0) {
               m_vkDeviceFuncs.CreateDescriptorUpdateTemplateKHR = (PFN_vkCreateDescriptorUpdateTemplateKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroyDescriptorUpdateTemplateKHR") == 0) {
               m_vkDeviceFuncs.DestroyDescriptorUpdateTemplateKHR = (PFN_vkDestroyDescriptorUpdateTemplateKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkUpdateDescriptorSetWithTemplateKHR") == 0) {
               m_vkDeviceFuncs.UpdateDescriptorSetWithTemplateKHR = (PFN_vkUpdateDescriptorSetWithTemplateKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdPushDescriptorSetWithTemplateKHR") == 0) {
               m_vkDeviceFuncs.CmdPushDescriptorSetWithTemplateKHR = (PFN_vkCmdPushDescriptorSetWithTemplateKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetSwapchainStatusKHR") == 0) {
               m_vkDeviceFuncs.GetSwapchainStatusKHR = (PFN_vkGetSwapchainStatusKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkImportFenceWin32HandleKHR") == 0) {
               m_vkDeviceFuncs.ImportFenceWin32HandleKHR = (PFN_vkImportFenceWin32HandleKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetFenceWin32HandleKHR") == 0) {
               m_vkDeviceFuncs.GetFenceWin32HandleKHR = (PFN_vkGetFenceWin32HandleKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkImportFenceFdKHR") == 0) {
               m_vkDeviceFuncs.ImportFenceFdKHR = (PFN_vkImportFenceFdKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetFenceFdKHR") == 0) {
               m_vkDeviceFuncs.GetFenceFdKHR = (PFN_vkGetFenceFdKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetImageMemoryRequirements2KHR") == 0) {
               m_vkDeviceFuncs.GetImageMemoryRequirements2KHR = (PFN_vkGetImageMemoryRequirements2KHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetBufferMemoryRequirements2KHR") == 0) {
               m_vkDeviceFuncs.GetBufferMemoryRequirements2KHR = (PFN_vkGetBufferMemoryRequirements2KHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetImageSparseMemoryRequirements2KHR") == 0) {
               m_vkDeviceFuncs.GetImageSparseMemoryRequirements2KHR = (PFN_vkGetImageSparseMemoryRequirements2KHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateSamplerYcbcrConversionKHR") == 0) {
               m_vkDeviceFuncs.CreateSamplerYcbcrConversionKHR = (PFN_vkCreateSamplerYcbcrConversionKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroySamplerYcbcrConversionKHR") == 0) {
               m_vkDeviceFuncs.DestroySamplerYcbcrConversionKHR = (PFN_vkDestroySamplerYcbcrConversionKHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkBindBufferMemory2KHR") == 0) {
               m_vkDeviceFuncs.BindBufferMemory2KHR = (PFN_vkBindBufferMemory2KHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkBindImageMemory2KHR") == 0) {
               m_vkDeviceFuncs.BindImageMemory2KHR = (PFN_vkBindImageMemory2KHR)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDebugMarkerSetObjectTagEXT") == 0) {
               m_vkDeviceFuncs.DebugMarkerSetObjectTagEXT = (PFN_vkDebugMarkerSetObjectTagEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDebugMarkerSetObjectNameEXT") == 0) {
               m_vkDeviceFuncs.DebugMarkerSetObjectNameEXT = (PFN_vkDebugMarkerSetObjectNameEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDebugMarkerBeginEXT") == 0) {
               m_vkDeviceFuncs.CmdDebugMarkerBeginEXT = (PFN_vkCmdDebugMarkerBeginEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDebugMarkerEndEXT") == 0) {
               m_vkDeviceFuncs.CmdDebugMarkerEndEXT = (PFN_vkCmdDebugMarkerEndEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDebugMarkerInsertEXT") == 0) {
               m_vkDeviceFuncs.CmdDebugMarkerInsertEXT = (PFN_vkCmdDebugMarkerInsertEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDrawIndirectCountAMD") == 0) {
               m_vkDeviceFuncs.CmdDrawIndirectCountAMD = (PFN_vkCmdDrawIndirectCountAMD)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDrawIndexedIndirectCountAMD") == 0) {
               m_vkDeviceFuncs.CmdDrawIndexedIndirectCountAMD = (PFN_vkCmdDrawIndexedIndirectCountAMD)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetShaderInfoAMD") == 0) {
               m_vkDeviceFuncs.GetShaderInfoAMD = (PFN_vkGetShaderInfoAMD)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#ifdef VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetMemoryWin32HandleNV") == 0) {
               m_vkDeviceFuncs.GetMemoryWin32HandleNV = (PFN_vkGetMemoryWin32HandleNV)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
#endif // VK_USE_PLATFORM_WIN32_KHR
            if (strcmp(pPacket->pName, "vkGetDeviceGroupPeerMemoryFeaturesKHX") == 0) {
               m_vkDeviceFuncs.GetDeviceGroupPeerMemoryFeaturesKHX = (PFN_vkGetDeviceGroupPeerMemoryFeaturesKHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdSetDeviceMaskKHX") == 0) {
               m_vkDeviceFuncs.CmdSetDeviceMaskKHX = (PFN_vkCmdSetDeviceMaskKHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdDispatchBaseKHX") == 0) {
               m_vkDeviceFuncs.CmdDispatchBaseKHX = (PFN_vkCmdDispatchBaseKHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetDeviceGroupPresentCapabilitiesKHX") == 0) {
               m_vkDeviceFuncs.GetDeviceGroupPresentCapabilitiesKHX = (PFN_vkGetDeviceGroupPresentCapabilitiesKHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetDeviceGroupSurfacePresentModesKHX") == 0) {
               m_vkDeviceFuncs.GetDeviceGroupSurfacePresentModesKHX = (PFN_vkGetDeviceGroupSurfacePresentModesKHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkAcquireNextImage2KHX") == 0) {
               m_vkDeviceFuncs.AcquireNextImage2KHX = (PFN_vkAcquireNextImage2KHX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdProcessCommandsNVX") == 0) {
               m_vkDeviceFuncs.CmdProcessCommandsNVX = (PFN_vkCmdProcessCommandsNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdReserveSpaceForCommandsNVX") == 0) {
               m_vkDeviceFuncs.CmdReserveSpaceForCommandsNVX = (PFN_vkCmdReserveSpaceForCommandsNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateIndirectCommandsLayoutNVX") == 0) {
               m_vkDeviceFuncs.CreateIndirectCommandsLayoutNVX = (PFN_vkCreateIndirectCommandsLayoutNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroyIndirectCommandsLayoutNVX") == 0) {
               m_vkDeviceFuncs.DestroyIndirectCommandsLayoutNVX = (PFN_vkDestroyIndirectCommandsLayoutNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateObjectTableNVX") == 0) {
               m_vkDeviceFuncs.CreateObjectTableNVX = (PFN_vkCreateObjectTableNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroyObjectTableNVX") == 0) {
               m_vkDeviceFuncs.DestroyObjectTableNVX = (PFN_vkDestroyObjectTableNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkRegisterObjectsNVX") == 0) {
               m_vkDeviceFuncs.RegisterObjectsNVX = (PFN_vkRegisterObjectsNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkUnregisterObjectsNVX") == 0) {
               m_vkDeviceFuncs.UnregisterObjectsNVX = (PFN_vkUnregisterObjectsNVX)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdSetViewportWScalingNV") == 0) {
               m_vkDeviceFuncs.CmdSetViewportWScalingNV = (PFN_vkCmdSetViewportWScalingNV)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDisplayPowerControlEXT") == 0) {
               m_vkDeviceFuncs.DisplayPowerControlEXT = (PFN_vkDisplayPowerControlEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkRegisterDeviceEventEXT") == 0) {
               m_vkDeviceFuncs.RegisterDeviceEventEXT = (PFN_vkRegisterDeviceEventEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkRegisterDisplayEventEXT") == 0) {
               m_vkDeviceFuncs.RegisterDisplayEventEXT = (PFN_vkRegisterDisplayEventEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetSwapchainCounterEXT") == 0) {
               m_vkDeviceFuncs.GetSwapchainCounterEXT = (PFN_vkGetSwapchainCounterEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetRefreshCycleDurationGOOGLE") == 0) {
               m_vkDeviceFuncs.GetRefreshCycleDurationGOOGLE = (PFN_vkGetRefreshCycleDurationGOOGLE)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetPastPresentationTimingGOOGLE") == 0) {
               m_vkDeviceFuncs.GetPastPresentationTimingGOOGLE = (PFN_vkGetPastPresentationTimingGOOGLE)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdSetDiscardRectangleEXT") == 0) {
               m_vkDeviceFuncs.CmdSetDiscardRectangleEXT = (PFN_vkCmdSetDiscardRectangleEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkSetHdrMetadataEXT") == 0) {
               m_vkDeviceFuncs.SetHdrMetadataEXT = (PFN_vkSetHdrMetadataEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCmdSetSampleLocationsEXT") == 0) {
               m_vkDeviceFuncs.CmdSetSampleLocationsEXT = (PFN_vkCmdSetSampleLocationsEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkCreateValidationCacheEXT") == 0) {
               m_vkDeviceFuncs.CreateValidationCacheEXT = (PFN_vkCreateValidationCacheEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkDestroyValidationCacheEXT") == 0) {
               m_vkDeviceFuncs.DestroyValidationCacheEXT = (PFN_vkDestroyValidationCacheEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkMergeValidationCachesEXT") == 0) {
               m_vkDeviceFuncs.MergeValidationCachesEXT = (PFN_vkMergeValidationCachesEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetValidationCacheDataEXT") == 0) {
               m_vkDeviceFuncs.GetValidationCacheDataEXT = (PFN_vkGetValidationCacheDataEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            if (strcmp(pPacket->pName, "vkGetMemoryHostPointerPropertiesEXT") == 0) {
               m_vkDeviceFuncs.GetMemoryHostPointerPropertiesEXT = (PFN_vkGetMemoryHostPointerPropertiesEXT)vkGetDeviceProcAddr(remappeddevice, pPacket->pName);
            }
            m_vkDeviceFuncs.GetDeviceProcAddr(remappeddevice, pPacket->pName);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDevice: { 
            packet_vkCreateDevice* pPacket = (packet_vkCreateDevice*)(packet->pBody);
            replayResult = manually_replay_vkCreateDevice(pPacket);
            CHECK_RETURN_VALUE(vkCreateDevice);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyDevice: { 
            packet_vkDestroyDevice* pPacket = (packet_vkDestroyDevice*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyDevice() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyDevice(remappeddevice, pPacket->pAllocator);
            if (replayResult == VK_SUCCESS) {
                m_pCBDump = NULL;
                m_pDSDump = NULL;
                m_objMapper.rm_from_devices_map(pPacket->device);
                m_display->m_initedVK = false;
            }
            break;
        }
        case VKTRACE_TPI_VK_vkEnumerateInstanceExtensionProperties: { 
            packet_vkEnumerateInstanceExtensionProperties* pPacket = (packet_vkEnumerateInstanceExtensionProperties*)(packet->pBody);
            // No need to remap pLayerName
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.EnumerateInstanceExtensionProperties(pPacket->pLayerName, pPacket->pPropertyCount, pPacket->pProperties);
            if (replayResult == VK_ERROR_LAYER_NOT_PRESENT || replayResult == VK_INCOMPLETE) {
                replayResult = VK_SUCCESS;
            }
            CHECK_RETURN_VALUE(vkEnumerateInstanceExtensionProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkEnumerateDeviceExtensionProperties: { 
            packet_vkEnumerateDeviceExtensionProperties* pPacket = (packet_vkEnumerateDeviceExtensionProperties*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in EnumerateDeviceExtensionProperties() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pLayerName
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.EnumerateDeviceExtensionProperties(remappedphysicalDevice, pPacket->pLayerName, pPacket->pPropertyCount, pPacket->pProperties);
            if (replayResult == VK_ERROR_LAYER_NOT_PRESENT || replayResult == VK_INCOMPLETE) {
                replayResult = VK_SUCCESS;
            }
            CHECK_RETURN_VALUE(vkEnumerateDeviceExtensionProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkEnumerateInstanceLayerProperties: { 
            packet_vkEnumerateInstanceLayerProperties* pPacket = (packet_vkEnumerateInstanceLayerProperties*)(packet->pBody);
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.EnumerateInstanceLayerProperties(pPacket->pPropertyCount, pPacket->pProperties);
            if (replayResult == VK_ERROR_LAYER_NOT_PRESENT || replayResult == VK_INCOMPLETE) {
                replayResult = VK_SUCCESS;
            }
            CHECK_RETURN_VALUE(vkEnumerateInstanceLayerProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkEnumerateDeviceLayerProperties: { 
            packet_vkEnumerateDeviceLayerProperties* pPacket = (packet_vkEnumerateDeviceLayerProperties*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in EnumerateDeviceLayerProperties() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.EnumerateDeviceLayerProperties(remappedphysicalDevice, pPacket->pPropertyCount, pPacket->pProperties);
            if (replayResult == VK_ERROR_LAYER_NOT_PRESENT || replayResult == VK_INCOMPLETE) {
                replayResult = VK_SUCCESS;
            }
            CHECK_RETURN_VALUE(vkEnumerateDeviceLayerProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDeviceQueue: { 
            packet_vkGetDeviceQueue* pPacket = (packet_vkGetDeviceQueue*)(packet->pBody);
            VkQueue local_pQueue;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceQueue() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap queueFamilyIndex
            // No need to remap queueIndex
            m_vkDeviceFuncs.GetDeviceQueue(remappeddevice, pPacket->queueFamilyIndex, pPacket->queueIndex, &local_pQueue);
                m_objMapper.add_to_queues_map(*(pPacket->pQueue), local_pQueue);
            break;
        }
        case VKTRACE_TPI_VK_vkQueueSubmit: { 
            packet_vkQueueSubmit* pPacket = (packet_vkQueueSubmit*)(packet->pBody);
            replayResult = manually_replay_vkQueueSubmit(pPacket);
            CHECK_RETURN_VALUE(vkQueueSubmit);
            break;
        }
        case VKTRACE_TPI_VK_vkQueueWaitIdle: { 
            packet_vkQueueWaitIdle* pPacket = (packet_vkQueueWaitIdle*)(packet->pBody);
            VkQueue remappedqueue = m_objMapper.remap_queues(pPacket->queue);
            if (pPacket->queue != VK_NULL_HANDLE && remappedqueue == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in QueueWaitIdle() due to invalid remapped VkQueue.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.QueueWaitIdle(remappedqueue);
            CHECK_RETURN_VALUE(vkQueueWaitIdle);
            break;
        }
        case VKTRACE_TPI_VK_vkDeviceWaitIdle: { 
            packet_vkDeviceWaitIdle* pPacket = (packet_vkDeviceWaitIdle*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DeviceWaitIdle() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.DeviceWaitIdle(remappeddevice);
            CHECK_RETURN_VALUE(vkDeviceWaitIdle);
            break;
        }
        case VKTRACE_TPI_VK_vkAllocateMemory: { 
            packet_vkAllocateMemory* pPacket = (packet_vkAllocateMemory*)(packet->pBody);
            replayResult = manually_replay_vkAllocateMemory(pPacket);
            CHECK_RETURN_VALUE(vkAllocateMemory);
            break;
        }
        case VKTRACE_TPI_VK_vkFreeMemory: { 
            packet_vkFreeMemory* pPacket = (packet_vkFreeMemory*)(packet->pBody);
            manually_replay_vkFreeMemory(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkMapMemory: { 
            packet_vkMapMemory* pPacket = (packet_vkMapMemory*)(packet->pBody);
            replayResult = manually_replay_vkMapMemory(pPacket);
            CHECK_RETURN_VALUE(vkMapMemory);
            break;
        }
        case VKTRACE_TPI_VK_vkUnmapMemory: { 
            packet_vkUnmapMemory* pPacket = (packet_vkUnmapMemory*)(packet->pBody);
            manually_replay_vkUnmapMemory(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkFlushMappedMemoryRanges: { 
            packet_vkFlushMappedMemoryRanges* pPacket = (packet_vkFlushMappedMemoryRanges*)(packet->pBody);
            replayResult = manually_replay_vkFlushMappedMemoryRanges(pPacket);
            CHECK_RETURN_VALUE(vkFlushMappedMemoryRanges);
            break;
        }
        case VKTRACE_TPI_VK_vkInvalidateMappedMemoryRanges: { 
            packet_vkInvalidateMappedMemoryRanges* pPacket = (packet_vkInvalidateMappedMemoryRanges*)(packet->pBody);
            replayResult = manually_replay_vkInvalidateMappedMemoryRanges(pPacket);
            CHECK_RETURN_VALUE(vkInvalidateMappedMemoryRanges);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDeviceMemoryCommitment: { 
            packet_vkGetDeviceMemoryCommitment* pPacket = (packet_vkGetDeviceMemoryCommitment*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceMemoryCommitment() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDeviceMemory remappedmemory = m_objMapper.remap_devicememorys(pPacket->memory);
            if (pPacket->memory != VK_NULL_HANDLE && remappedmemory == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceMemoryCommitment() due to invalid remapped VkDeviceMemory.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCommittedMemoryInBytes
            m_vkDeviceFuncs.GetDeviceMemoryCommitment(remappeddevice, remappedmemory, pPacket->pCommittedMemoryInBytes);
            break;
        }
        case VKTRACE_TPI_VK_vkBindBufferMemory: { 
            packet_vkBindBufferMemory* pPacket = (packet_vkBindBufferMemory*)(packet->pBody);
            replayResult = manually_replay_vkBindBufferMemory(pPacket);
            CHECK_RETURN_VALUE(vkBindBufferMemory);
            break;
        }
        case VKTRACE_TPI_VK_vkBindImageMemory: { 
            packet_vkBindImageMemory* pPacket = (packet_vkBindImageMemory*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in BindImageMemory() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedimage = m_objMapper.remap_images(pPacket->image);
            if (pPacket->image != VK_NULL_HANDLE && remappedimage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in BindImageMemory() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDeviceMemory remappedmemory = m_objMapper.remap_devicememorys(pPacket->memory);
            if (pPacket->memory != VK_NULL_HANDLE && remappedmemory == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in BindImageMemory() due to invalid remapped VkDeviceMemory.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap memoryOffset
            replayResult = m_vkDeviceFuncs.BindImageMemory(remappeddevice, remappedimage, remappedmemory, pPacket->memoryOffset);
            CHECK_RETURN_VALUE(vkBindImageMemory);
            break;
        }
        case VKTRACE_TPI_VK_vkGetBufferMemoryRequirements: { 
            packet_vkGetBufferMemoryRequirements* pPacket = (packet_vkGetBufferMemoryRequirements*)(packet->pBody);
            manually_replay_vkGetBufferMemoryRequirements(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetImageMemoryRequirements: { 
            packet_vkGetImageMemoryRequirements* pPacket = (packet_vkGetImageMemoryRequirements*)(packet->pBody);
            manually_replay_vkGetImageMemoryRequirements(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetImageSparseMemoryRequirements: { 
            packet_vkGetImageSparseMemoryRequirements* pPacket = (packet_vkGetImageSparseMemoryRequirements*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetImageSparseMemoryRequirements() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedimage = m_objMapper.remap_images(pPacket->image);
            if (pPacket->image != VK_NULL_HANDLE && remappedimage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetImageSparseMemoryRequirements() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSparseMemoryRequirementCount
            // No need to remap pSparseMemoryRequirements
            m_vkDeviceFuncs.GetImageSparseMemoryRequirements(remappeddevice, remappedimage, pPacket->pSparseMemoryRequirementCount, pPacket->pSparseMemoryRequirements);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSparseImageFormatProperties: { 
            packet_vkGetPhysicalDeviceSparseImageFormatProperties* pPacket = (packet_vkGetPhysicalDeviceSparseImageFormatProperties*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceSparseImageFormatProperties(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkQueueBindSparse: { 
            packet_vkQueueBindSparse* pPacket = (packet_vkQueueBindSparse*)(packet->pBody);
            replayResult = manually_replay_vkQueueBindSparse(pPacket);
            CHECK_RETURN_VALUE(vkQueueBindSparse);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateFence: { 
            packet_vkCreateFence* pPacket = (packet_vkCreateFence*)(packet->pBody);
            VkFence local_pFence;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateFence() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateFence(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pFence);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_fences_map(*(pPacket->pFence), local_pFence);
            }
            CHECK_RETURN_VALUE(vkCreateFence);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyFence: { 
            packet_vkDestroyFence* pPacket = (packet_vkDestroyFence*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyFence() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkFence remappedfence = m_objMapper.remap_fences(pPacket->fence);
            if (pPacket->fence != VK_NULL_HANDLE && remappedfence == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyFence() due to invalid remapped VkFence.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyFence(remappeddevice, remappedfence, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkResetFences: { 
            packet_vkResetFences* pPacket = (packet_vkResetFences*)(packet->pBody);
            VkFence* fences = VKTRACE_NEW_ARRAY(VkFence, pPacket->fenceCount);
            for (uint32_t i = 0; i < pPacket->fenceCount; i++) {
                fences[i] = m_objMapper.remap_fences(pPacket->pFences[i]);
                if (fences[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in vkResetFences() due to invalid remapped VkFence.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetFences() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap fenceCount
            // No need to remap pFences
            replayResult = m_vkDeviceFuncs.ResetFences(remappeddevice, pPacket->fenceCount, fences);
            VKTRACE_DELETE(fences);
            CHECK_RETURN_VALUE(vkResetFences);
            break;
        }
        case VKTRACE_TPI_VK_vkGetFenceStatus: { 
            packet_vkGetFenceStatus* pPacket = (packet_vkGetFenceStatus*)(packet->pBody);
            do {
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetFenceStatus() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkFence remappedfence = m_objMapper.remap_fences(pPacket->fence);
            if (pPacket->fence != VK_NULL_HANDLE && remappedfence == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetFenceStatus() due to invalid remapped VkFence.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.GetFenceStatus(remappeddevice, remappedfence);
            } while (replayResult != pPacket->result  && pPacket->result == VK_SUCCESS);
            if (pPacket->result != VK_NOT_READY || replayResult != VK_SUCCESS)
            CHECK_RETURN_VALUE(vkGetFenceStatus);
            break;
        }
        case VKTRACE_TPI_VK_vkWaitForFences: { 
            packet_vkWaitForFences* pPacket = (packet_vkWaitForFences*)(packet->pBody);
            replayResult = manually_replay_vkWaitForFences(pPacket);
            CHECK_RETURN_VALUE(vkWaitForFences);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateSemaphore: { 
            packet_vkCreateSemaphore* pPacket = (packet_vkCreateSemaphore*)(packet->pBody);
            VkSemaphore local_pSemaphore;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateSemaphore() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateSemaphore(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pSemaphore);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_semaphores_map(*(pPacket->pSemaphore), local_pSemaphore);
            }
            CHECK_RETURN_VALUE(vkCreateSemaphore);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroySemaphore: { 
            packet_vkDestroySemaphore* pPacket = (packet_vkDestroySemaphore*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySemaphore() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSemaphore remappedsemaphore = m_objMapper.remap_semaphores(pPacket->semaphore);
            if (pPacket->semaphore != VK_NULL_HANDLE && remappedsemaphore == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySemaphore() due to invalid remapped VkSemaphore.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroySemaphore(remappeddevice, remappedsemaphore, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateEvent: { 
            packet_vkCreateEvent* pPacket = (packet_vkCreateEvent*)(packet->pBody);
            VkEvent local_pEvent;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateEvent() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateEvent(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pEvent);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_events_map(*(pPacket->pEvent), local_pEvent);
            }
            CHECK_RETURN_VALUE(vkCreateEvent);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyEvent: { 
            packet_vkDestroyEvent* pPacket = (packet_vkDestroyEvent*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyEvent() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyEvent() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyEvent(remappeddevice, remappedevent, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkGetEventStatus: { 
            packet_vkGetEventStatus* pPacket = (packet_vkGetEventStatus*)(packet->pBody);
            do {
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetEventStatus() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetEventStatus() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.GetEventStatus(remappeddevice, remappedevent);
            } while ((pPacket->result == VK_EVENT_SET || pPacket->result == VK_EVENT_RESET) && replayResult != pPacket->result);
            if (pPacket->result != VK_NOT_READY || replayResult != VK_SUCCESS)
            CHECK_RETURN_VALUE(vkGetEventStatus);
            break;
        }
        case VKTRACE_TPI_VK_vkSetEvent: { 
            packet_vkSetEvent* pPacket = (packet_vkSetEvent*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in SetEvent() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in SetEvent() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.SetEvent(remappeddevice, remappedevent);
            CHECK_RETURN_VALUE(vkSetEvent);
            break;
        }
        case VKTRACE_TPI_VK_vkResetEvent: { 
            packet_vkResetEvent* pPacket = (packet_vkResetEvent*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetEvent() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetEvent() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.ResetEvent(remappeddevice, remappedevent);
            CHECK_RETURN_VALUE(vkResetEvent);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateQueryPool: { 
            packet_vkCreateQueryPool* pPacket = (packet_vkCreateQueryPool*)(packet->pBody);
            VkQueryPool local_pQueryPool;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateQueryPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateQueryPool(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pQueryPool);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_querypools_map(*(pPacket->pQueryPool), local_pQueryPool);
            }
            CHECK_RETURN_VALUE(vkCreateQueryPool);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyQueryPool: { 
            packet_vkDestroyQueryPool* pPacket = (packet_vkDestroyQueryPool*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyQueryPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyQueryPool() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyQueryPool(remappeddevice, remappedqueryPool, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkGetQueryPoolResults: { 
            packet_vkGetQueryPoolResults* pPacket = (packet_vkGetQueryPoolResults*)(packet->pBody);
            do {
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetQueryPoolResults() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetQueryPoolResults() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstQuery
            // No need to remap queryCount
            // No need to remap dataSize
            // No need to remap pData
            // No need to remap stride
            // No need to remap flags
            replayResult = m_vkDeviceFuncs.GetQueryPoolResults(remappeddevice, remappedqueryPool, pPacket->firstQuery, pPacket->queryCount, pPacket->dataSize, pPacket->pData, pPacket->stride, pPacket->flags);
            } while (pPacket->result == VK_SUCCESS && replayResult != pPacket->result);
            if (pPacket->result != VK_NOT_READY || replayResult != VK_SUCCESS)
            CHECK_RETURN_VALUE(vkGetQueryPoolResults);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateBuffer: { 
            packet_vkCreateBuffer* pPacket = (packet_vkCreateBuffer*)(packet->pBody);
            replayResult = manually_replay_vkCreateBuffer(pPacket);
            CHECK_RETURN_VALUE(vkCreateBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyBuffer: { 
            packet_vkDestroyBuffer* pPacket = (packet_vkDestroyBuffer*)(packet->pBody);
            manually_replay_vkDestroyBuffer(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateBufferView: { 
            packet_vkCreateBufferView* pPacket = (packet_vkCreateBufferView*)(packet->pBody);
            VkBufferViewCreateInfo createInfo;
            memcpy(&createInfo, pPacket->pCreateInfo, sizeof(VkBufferViewCreateInfo))
;            createInfo.buffer = m_objMapper.remap_buffers(pPacket->pCreateInfo->buffer);
            if (createInfo.buffer == VK_NULL_HANDLE && pPacket->pCreateInfo->buffer != VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in vkCreateBufferView() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBufferView local_pView;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateBufferView() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateBufferView(remappeddevice, &createInfo, NULL, &local_pView);

            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_bufferviews_map(*(pPacket->pView), local_pView);
            }
            CHECK_RETURN_VALUE(vkCreateBufferView);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyBufferView: { 
            packet_vkDestroyBufferView* pPacket = (packet_vkDestroyBufferView*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyBufferView() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBufferView remappedbufferView = m_objMapper.remap_bufferviews(pPacket->bufferView);
            if (pPacket->bufferView != VK_NULL_HANDLE && remappedbufferView == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyBufferView() due to invalid remapped VkBufferView.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyBufferView(remappeddevice, remappedbufferView, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateImage: { 
            packet_vkCreateImage* pPacket = (packet_vkCreateImage*)(packet->pBody);
            replayResult = manually_replay_vkCreateImage(pPacket);
            CHECK_RETURN_VALUE(vkCreateImage);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyImage: { 
            packet_vkDestroyImage* pPacket = (packet_vkDestroyImage*)(packet->pBody);
            manually_replay_vkDestroyImage(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetImageSubresourceLayout: { 
            packet_vkGetImageSubresourceLayout* pPacket = (packet_vkGetImageSubresourceLayout*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetImageSubresourceLayout() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedimage = m_objMapper.remap_images(pPacket->image);
            if (pPacket->image != VK_NULL_HANDLE && remappedimage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetImageSubresourceLayout() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSubresource
            // No need to remap pLayout
            m_vkDeviceFuncs.GetImageSubresourceLayout(remappeddevice, remappedimage, pPacket->pSubresource, pPacket->pLayout);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateImageView: { 
            packet_vkCreateImageView* pPacket = (packet_vkCreateImageView*)(packet->pBody);
            VkImageViewCreateInfo createInfo;
            memcpy(&createInfo, pPacket->pCreateInfo, sizeof(VkImageViewCreateInfo))
;            createInfo.image = m_objMapper.remap_images(pPacket->pCreateInfo->image);
            if (createInfo.image == VK_NULL_HANDLE && pPacket->pCreateInfo->image != VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in vkCreateImageView() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImageView local_pView;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateImageView() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateImageView(remappeddevice, &createInfo, NULL, &local_pView);

            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_imageviews_map(*(pPacket->pView), local_pView);
            }
            CHECK_RETURN_VALUE(vkCreateImageView);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyImageView: { 
            packet_vkDestroyImageView* pPacket = (packet_vkDestroyImageView*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyImageView() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImageView remappedimageView = m_objMapper.remap_imageviews(pPacket->imageView);
            if (pPacket->imageView != VK_NULL_HANDLE && remappedimageView == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyImageView() due to invalid remapped VkImageView.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyImageView(remappeddevice, remappedimageView, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateShaderModule: { 
            packet_vkCreateShaderModule* pPacket = (packet_vkCreateShaderModule*)(packet->pBody);
            VkShaderModule local_pShaderModule;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateShaderModule() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateShaderModule(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pShaderModule);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_shadermodules_map(*(pPacket->pShaderModule), local_pShaderModule);
            }
            CHECK_RETURN_VALUE(vkCreateShaderModule);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyShaderModule: { 
            packet_vkDestroyShaderModule* pPacket = (packet_vkDestroyShaderModule*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyShaderModule() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkShaderModule remappedshaderModule = m_objMapper.remap_shadermodules(pPacket->shaderModule);
            if (pPacket->shaderModule != VK_NULL_HANDLE && remappedshaderModule == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyShaderModule() due to invalid remapped VkShaderModule.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyShaderModule(remappeddevice, remappedshaderModule, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreatePipelineCache: { 
            packet_vkCreatePipelineCache* pPacket = (packet_vkCreatePipelineCache*)(packet->pBody);
            VkPipelineCache local_pPipelineCache;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreatePipelineCache() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreatePipelineCache(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pPipelineCache);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_pipelinecaches_map(*(pPacket->pPipelineCache), local_pPipelineCache);
            }
            CHECK_RETURN_VALUE(vkCreatePipelineCache);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyPipelineCache: { 
            packet_vkDestroyPipelineCache* pPacket = (packet_vkDestroyPipelineCache*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipelineCache() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipelineCache remappedpipelineCache = m_objMapper.remap_pipelinecaches(pPacket->pipelineCache);
            if (pPacket->pipelineCache != VK_NULL_HANDLE && remappedpipelineCache == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipelineCache() due to invalid remapped VkPipelineCache.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyPipelineCache(remappeddevice, remappedpipelineCache, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPipelineCacheData: { 
            packet_vkGetPipelineCacheData* pPacket = (packet_vkGetPipelineCacheData*)(packet->pBody);
            replayResult = manually_replay_vkGetPipelineCacheData(pPacket);
            CHECK_RETURN_VALUE(vkGetPipelineCacheData);
            break;
        }
        case VKTRACE_TPI_VK_vkMergePipelineCaches: { 
            packet_vkMergePipelineCaches* pPacket = (packet_vkMergePipelineCaches*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in MergePipelineCaches() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipelineCache remappeddstCache = m_objMapper.remap_pipelinecaches(pPacket->dstCache);
            if (pPacket->dstCache != VK_NULL_HANDLE && remappeddstCache == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in MergePipelineCaches() due to invalid remapped VkPipelineCache.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcCacheCount
            VkPipelineCache *remappedpSrcCaches = new VkPipelineCache[pPacket->srcCacheCount];
            for (uint32_t i = 0; i < pPacket->srcCacheCount; i++) {
                remappedpSrcCaches[i] = m_objMapper.remap_pipelinecaches(pPacket->pSrcCaches[i]);
                if (pPacket->pSrcCaches[i] != VK_NULL_HANDLE && remappedpSrcCaches[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in MergePipelineCaches() due to invalid remapped VkPipelineCache.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            replayResult = m_vkDeviceFuncs.MergePipelineCaches(remappeddevice, remappeddstCache, pPacket->srcCacheCount, remappedpSrcCaches);
            delete[] remappedpSrcCaches;
            CHECK_RETURN_VALUE(vkMergePipelineCaches);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateGraphicsPipelines: { 
            packet_vkCreateGraphicsPipelines* pPacket = (packet_vkCreateGraphicsPipelines*)(packet->pBody);
            replayResult = manually_replay_vkCreateGraphicsPipelines(pPacket);
            CHECK_RETURN_VALUE(vkCreateGraphicsPipelines);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateComputePipelines: { 
            packet_vkCreateComputePipelines* pPacket = (packet_vkCreateComputePipelines*)(packet->pBody);
            replayResult = manually_replay_vkCreateComputePipelines(pPacket);
            CHECK_RETURN_VALUE(vkCreateComputePipelines);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyPipeline: { 
            packet_vkDestroyPipeline* pPacket = (packet_vkDestroyPipeline*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipeline() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipeline remappedpipeline = m_objMapper.remap_pipelines(pPacket->pipeline);
            if (pPacket->pipeline != VK_NULL_HANDLE && remappedpipeline == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipeline() due to invalid remapped VkPipeline.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyPipeline(remappeddevice, remappedpipeline, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreatePipelineLayout: { 
            packet_vkCreatePipelineLayout* pPacket = (packet_vkCreatePipelineLayout*)(packet->pBody);
            replayResult = manually_replay_vkCreatePipelineLayout(pPacket);
            CHECK_RETURN_VALUE(vkCreatePipelineLayout);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyPipelineLayout: { 
            packet_vkDestroyPipelineLayout* pPacket = (packet_vkDestroyPipelineLayout*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipelineLayout() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipelineLayout remappedpipelineLayout = m_objMapper.remap_pipelinelayouts(pPacket->pipelineLayout);
            if (pPacket->pipelineLayout != VK_NULL_HANDLE && remappedpipelineLayout == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyPipelineLayout() due to invalid remapped VkPipelineLayout.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyPipelineLayout(remappeddevice, remappedpipelineLayout, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateSampler: { 
            packet_vkCreateSampler* pPacket = (packet_vkCreateSampler*)(packet->pBody);
            VkSampler local_pSampler;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateSampler() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateSampler(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pSampler);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_samplers_map(*(pPacket->pSampler), local_pSampler);
            }
            CHECK_RETURN_VALUE(vkCreateSampler);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroySampler: { 
            packet_vkDestroySampler* pPacket = (packet_vkDestroySampler*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySampler() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSampler remappedsampler = m_objMapper.remap_samplers(pPacket->sampler);
            if (pPacket->sampler != VK_NULL_HANDLE && remappedsampler == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySampler() due to invalid remapped VkSampler.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroySampler(remappeddevice, remappedsampler, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDescriptorSetLayout: { 
            packet_vkCreateDescriptorSetLayout* pPacket = (packet_vkCreateDescriptorSetLayout*)(packet->pBody);
            replayResult = manually_replay_vkCreateDescriptorSetLayout(pPacket);
            CHECK_RETURN_VALUE(vkCreateDescriptorSetLayout);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyDescriptorSetLayout: { 
            packet_vkDestroyDescriptorSetLayout* pPacket = (packet_vkDestroyDescriptorSetLayout*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyDescriptorSetLayout() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDescriptorSetLayout remappeddescriptorSetLayout = m_objMapper.remap_descriptorsetlayouts(pPacket->descriptorSetLayout);
            if (pPacket->descriptorSetLayout != VK_NULL_HANDLE && remappeddescriptorSetLayout == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyDescriptorSetLayout() due to invalid remapped VkDescriptorSetLayout.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyDescriptorSetLayout(remappeddevice, remappeddescriptorSetLayout, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDescriptorPool: { 
            packet_vkCreateDescriptorPool* pPacket = (packet_vkCreateDescriptorPool*)(packet->pBody);
            VkDescriptorPool local_pDescriptorPool;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateDescriptorPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateDescriptorPool(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pDescriptorPool);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_descriptorpools_map(*(pPacket->pDescriptorPool), local_pDescriptorPool);
            }
            CHECK_RETURN_VALUE(vkCreateDescriptorPool);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyDescriptorPool: { 
            packet_vkDestroyDescriptorPool* pPacket = (packet_vkDestroyDescriptorPool*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyDescriptorPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDescriptorPool remappeddescriptorPool = m_objMapper.remap_descriptorpools(pPacket->descriptorPool);
            if (pPacket->descriptorPool != VK_NULL_HANDLE && remappeddescriptorPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyDescriptorPool() due to invalid remapped VkDescriptorPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyDescriptorPool(remappeddevice, remappeddescriptorPool, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkResetDescriptorPool: { 
            packet_vkResetDescriptorPool* pPacket = (packet_vkResetDescriptorPool*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetDescriptorPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDescriptorPool remappeddescriptorPool = m_objMapper.remap_descriptorpools(pPacket->descriptorPool);
            if (pPacket->descriptorPool != VK_NULL_HANDLE && remappeddescriptorPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetDescriptorPool() due to invalid remapped VkDescriptorPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap flags
            replayResult = m_vkDeviceFuncs.ResetDescriptorPool(remappeddevice, remappeddescriptorPool, pPacket->flags);
            CHECK_RETURN_VALUE(vkResetDescriptorPool);
            break;
        }
        case VKTRACE_TPI_VK_vkAllocateDescriptorSets: { 
            packet_vkAllocateDescriptorSets* pPacket = (packet_vkAllocateDescriptorSets*)(packet->pBody);
            VkDescriptorSet* local_pDescriptorSets = (VkDescriptorSet*)malloc(pPacket->pAllocateInfo->descriptorSetCount * sizeof(VkDescriptorSet));
            VkDescriptorSetLayout* local_pSetLayouts = (VkDescriptorSetLayout*)malloc(pPacket->pAllocateInfo->descriptorSetCount * sizeof(VkDescriptorSetLayout));
            VkDescriptorSetAllocateInfo local_AllocInfo, *local_pAllocateInfo = &local_AllocInfo;
            VkDescriptorPool local_descPool;
            local_descPool = m_objMapper.remap_descriptorpools(pPacket->pAllocateInfo->descriptorPool);
            if (local_descPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in vkAllocateDescriptorSets() due to invalid remapped VkDescriptorPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            for (uint32_t i = 0; i < pPacket->pAllocateInfo->descriptorSetCount; i++) {
                local_pSetLayouts[i] = m_objMapper.remap_descriptorsetlayouts(pPacket->pAllocateInfo->pSetLayouts[i]);
                if (local_pSetLayouts[i] == VK_NULL_HANDLE) { 
                    vktrace_LogError("Error detected in vkAllocateDescriptorSets() due to invalid remapped VkDescriptorSetLayout.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            memcpy(local_pAllocateInfo, pPacket->pAllocateInfo, sizeof(VkDescriptorSetAllocateInfo));
            local_pAllocateInfo->pSetLayouts = local_pSetLayouts;
            local_pAllocateInfo->descriptorPool = local_descPool;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AllocateDescriptorSets() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocateInfo
            replayResult = m_vkDeviceFuncs.AllocateDescriptorSets(remappeddevice, local_pAllocateInfo, local_pDescriptorSets);
            if (replayResult == VK_SUCCESS) {
                for (uint32_t i = 0; i < pPacket->pAllocateInfo->descriptorSetCount; i++) {
                    m_objMapper.add_to_descriptorsets_map(pPacket->pDescriptorSets[i], local_pDescriptorSets[i]);
                }
            }
            free(local_pSetLayouts);
            free(local_pDescriptorSets);
            CHECK_RETURN_VALUE(vkAllocateDescriptorSets);
            break;
        }
        case VKTRACE_TPI_VK_vkFreeDescriptorSets: { 
            packet_vkFreeDescriptorSets* pPacket = (packet_vkFreeDescriptorSets*)(packet->pBody);
            replayResult = manually_replay_vkFreeDescriptorSets(pPacket);
            CHECK_RETURN_VALUE(vkFreeDescriptorSets);
            break;
        }
        case VKTRACE_TPI_VK_vkUpdateDescriptorSets: { 
            packet_vkUpdateDescriptorSets* pPacket = (packet_vkUpdateDescriptorSets*)(packet->pBody);
            manually_replay_vkUpdateDescriptorSets(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateFramebuffer: { 
            packet_vkCreateFramebuffer* pPacket = (packet_vkCreateFramebuffer*)(packet->pBody);
            replayResult = manually_replay_vkCreateFramebuffer(pPacket);
            CHECK_RETURN_VALUE(vkCreateFramebuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyFramebuffer: { 
            packet_vkDestroyFramebuffer* pPacket = (packet_vkDestroyFramebuffer*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyFramebuffer() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkFramebuffer remappedframebuffer = m_objMapper.remap_framebuffers(pPacket->framebuffer);
            if (pPacket->framebuffer != VK_NULL_HANDLE && remappedframebuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyFramebuffer() due to invalid remapped VkFramebuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyFramebuffer(remappeddevice, remappedframebuffer, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateRenderPass: { 
            packet_vkCreateRenderPass* pPacket = (packet_vkCreateRenderPass*)(packet->pBody);
            replayResult = manually_replay_vkCreateRenderPass(pPacket);
            CHECK_RETURN_VALUE(vkCreateRenderPass);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyRenderPass: { 
            packet_vkDestroyRenderPass* pPacket = (packet_vkDestroyRenderPass*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyRenderPass() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkRenderPass remappedrenderPass = m_objMapper.remap_renderpasss(pPacket->renderPass);
            if (pPacket->renderPass != VK_NULL_HANDLE && remappedrenderPass == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyRenderPass() due to invalid remapped VkRenderPass.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyRenderPass(remappeddevice, remappedrenderPass, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkGetRenderAreaGranularity: { 
            packet_vkGetRenderAreaGranularity* pPacket = (packet_vkGetRenderAreaGranularity*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetRenderAreaGranularity() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkRenderPass remappedrenderPass = m_objMapper.remap_renderpasss(pPacket->renderPass);
            if (pPacket->renderPass != VK_NULL_HANDLE && remappedrenderPass == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetRenderAreaGranularity() due to invalid remapped VkRenderPass.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGranularity
            m_vkDeviceFuncs.GetRenderAreaGranularity(remappeddevice, remappedrenderPass, pPacket->pGranularity);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateCommandPool: { 
            packet_vkCreateCommandPool* pPacket = (packet_vkCreateCommandPool*)(packet->pBody);
            replayResult = manually_replay_vkCreateCommandPool(pPacket);
            CHECK_RETURN_VALUE(vkCreateCommandPool);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyCommandPool: { 
            packet_vkDestroyCommandPool* pPacket = (packet_vkDestroyCommandPool*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyCommandPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkCommandPool remappedcommandPool = m_objMapper.remap_commandpools(pPacket->commandPool);
            if (pPacket->commandPool != VK_NULL_HANDLE && remappedcommandPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyCommandPool() due to invalid remapped VkCommandPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyCommandPool(remappeddevice, remappedcommandPool, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkResetCommandPool: { 
            packet_vkResetCommandPool* pPacket = (packet_vkResetCommandPool*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetCommandPool() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkCommandPool remappedcommandPool = m_objMapper.remap_commandpools(pPacket->commandPool);
            if (pPacket->commandPool != VK_NULL_HANDLE && remappedcommandPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetCommandPool() due to invalid remapped VkCommandPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap flags
            replayResult = m_vkDeviceFuncs.ResetCommandPool(remappeddevice, remappedcommandPool, pPacket->flags);
            CHECK_RETURN_VALUE(vkResetCommandPool);
            break;
        }
        case VKTRACE_TPI_VK_vkAllocateCommandBuffers: { 
            packet_vkAllocateCommandBuffers* pPacket = (packet_vkAllocateCommandBuffers*)(packet->pBody);
            replayResult = manually_replay_vkAllocateCommandBuffers(pPacket);
            CHECK_RETURN_VALUE(vkAllocateCommandBuffers);
            break;
        }
        case VKTRACE_TPI_VK_vkFreeCommandBuffers: { 
            packet_vkFreeCommandBuffers* pPacket = (packet_vkFreeCommandBuffers*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in FreeCommandBuffers() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkCommandPool remappedcommandPool = m_objMapper.remap_commandpools(pPacket->commandPool);
            if (pPacket->commandPool != VK_NULL_HANDLE && remappedcommandPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in FreeCommandBuffers() due to invalid remapped VkCommandPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap commandBufferCount
            VkCommandBuffer *remappedpCommandBuffers = new VkCommandBuffer[pPacket->commandBufferCount];
            for (uint32_t i = 0; i < pPacket->commandBufferCount; i++) {
                remappedpCommandBuffers[i] = m_objMapper.remap_commandbuffers(pPacket->pCommandBuffers[i]);
                if (pPacket->pCommandBuffers[i] != VK_NULL_HANDLE && remappedpCommandBuffers[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in FreeCommandBuffers() due to invalid remapped VkCommandBuffer.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            m_vkDeviceFuncs.FreeCommandBuffers(remappeddevice, remappedcommandPool, pPacket->commandBufferCount, remappedpCommandBuffers);
            delete[] remappedpCommandBuffers;
            break;
        }
        case VKTRACE_TPI_VK_vkBeginCommandBuffer: { 
            packet_vkBeginCommandBuffer* pPacket = (packet_vkBeginCommandBuffer*)(packet->pBody);
            replayResult = manually_replay_vkBeginCommandBuffer(pPacket);
            CHECK_RETURN_VALUE(vkBeginCommandBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkEndCommandBuffer: { 
            packet_vkEndCommandBuffer* pPacket = (packet_vkEndCommandBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in EndCommandBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.EndCommandBuffer(remappedcommandBuffer);
            CHECK_RETURN_VALUE(vkEndCommandBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkResetCommandBuffer: { 
            packet_vkResetCommandBuffer* pPacket = (packet_vkResetCommandBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ResetCommandBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap flags
            replayResult = m_vkDeviceFuncs.ResetCommandBuffer(remappedcommandBuffer, pPacket->flags);
            CHECK_RETURN_VALUE(vkResetCommandBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBindPipeline: { 
            packet_vkCmdBindPipeline* pPacket = (packet_vkCmdBindPipeline*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBindPipeline() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pipelineBindPoint
            VkPipeline remappedpipeline = m_objMapper.remap_pipelines(pPacket->pipeline);
            if (pPacket->pipeline != VK_NULL_HANDLE && remappedpipeline == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBindPipeline() due to invalid remapped VkPipeline.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            m_vkDeviceFuncs.CmdBindPipeline(remappedcommandBuffer, pPacket->pipelineBindPoint, remappedpipeline);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetViewport: { 
            packet_vkCmdSetViewport* pPacket = (packet_vkCmdSetViewport*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetViewport() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstViewport
            // No need to remap viewportCount
            // No need to remap pViewports
            m_vkDeviceFuncs.CmdSetViewport(remappedcommandBuffer, pPacket->firstViewport, pPacket->viewportCount, pPacket->pViewports);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetScissor: { 
            packet_vkCmdSetScissor* pPacket = (packet_vkCmdSetScissor*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetScissor() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstScissor
            // No need to remap scissorCount
            // No need to remap pScissors
            m_vkDeviceFuncs.CmdSetScissor(remappedcommandBuffer, pPacket->firstScissor, pPacket->scissorCount, pPacket->pScissors);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetLineWidth: { 
            packet_vkCmdSetLineWidth* pPacket = (packet_vkCmdSetLineWidth*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetLineWidth() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap lineWidth
            m_vkDeviceFuncs.CmdSetLineWidth(remappedcommandBuffer, pPacket->lineWidth);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetDepthBias: { 
            packet_vkCmdSetDepthBias* pPacket = (packet_vkCmdSetDepthBias*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetDepthBias() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap depthBiasConstantFactor
            // No need to remap depthBiasClamp
            // No need to remap depthBiasSlopeFactor
            m_vkDeviceFuncs.CmdSetDepthBias(remappedcommandBuffer, pPacket->depthBiasConstantFactor, pPacket->depthBiasClamp, pPacket->depthBiasSlopeFactor);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetBlendConstants: { 
            packet_vkCmdSetBlendConstants* pPacket = (packet_vkCmdSetBlendConstants*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetBlendConstants() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap blendConstants
            m_vkDeviceFuncs.CmdSetBlendConstants(remappedcommandBuffer, pPacket->blendConstants);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetDepthBounds: { 
            packet_vkCmdSetDepthBounds* pPacket = (packet_vkCmdSetDepthBounds*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetDepthBounds() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap minDepthBounds
            // No need to remap maxDepthBounds
            m_vkDeviceFuncs.CmdSetDepthBounds(remappedcommandBuffer, pPacket->minDepthBounds, pPacket->maxDepthBounds);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetStencilCompareMask: { 
            packet_vkCmdSetStencilCompareMask* pPacket = (packet_vkCmdSetStencilCompareMask*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetStencilCompareMask() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap faceMask
            // No need to remap compareMask
            m_vkDeviceFuncs.CmdSetStencilCompareMask(remappedcommandBuffer, pPacket->faceMask, pPacket->compareMask);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetStencilWriteMask: { 
            packet_vkCmdSetStencilWriteMask* pPacket = (packet_vkCmdSetStencilWriteMask*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetStencilWriteMask() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap faceMask
            // No need to remap writeMask
            m_vkDeviceFuncs.CmdSetStencilWriteMask(remappedcommandBuffer, pPacket->faceMask, pPacket->writeMask);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetStencilReference: { 
            packet_vkCmdSetStencilReference* pPacket = (packet_vkCmdSetStencilReference*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetStencilReference() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap faceMask
            // No need to remap reference
            m_vkDeviceFuncs.CmdSetStencilReference(remappedcommandBuffer, pPacket->faceMask, pPacket->reference);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBindDescriptorSets: { 
            packet_vkCmdBindDescriptorSets* pPacket = (packet_vkCmdBindDescriptorSets*)(packet->pBody);
            manually_replay_vkCmdBindDescriptorSets(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBindIndexBuffer: { 
            packet_vkCmdBindIndexBuffer* pPacket = (packet_vkCmdBindIndexBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBindIndexBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBindIndexBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            // No need to remap indexType
            m_vkDeviceFuncs.CmdBindIndexBuffer(remappedcommandBuffer, remappedbuffer, pPacket->offset, pPacket->indexType);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBindVertexBuffers: { 
            packet_vkCmdBindVertexBuffers* pPacket = (packet_vkCmdBindVertexBuffers*)(packet->pBody);
            manually_replay_vkCmdBindVertexBuffers(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDraw: { 
            packet_vkCmdDraw* pPacket = (packet_vkCmdDraw*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDraw() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap vertexCount
            // No need to remap instanceCount
            // No need to remap firstVertex
            // No need to remap firstInstance
            m_vkDeviceFuncs.CmdDraw(remappedcommandBuffer, pPacket->vertexCount, pPacket->instanceCount, pPacket->firstVertex, pPacket->firstInstance);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDrawIndexed: { 
            packet_vkCmdDrawIndexed* pPacket = (packet_vkCmdDrawIndexed*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexed() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap indexCount
            // No need to remap instanceCount
            // No need to remap firstIndex
            // No need to remap vertexOffset
            // No need to remap firstInstance
            m_vkDeviceFuncs.CmdDrawIndexed(remappedcommandBuffer, pPacket->indexCount, pPacket->instanceCount, pPacket->firstIndex, pPacket->vertexOffset, pPacket->firstInstance);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDrawIndirect: { 
            packet_vkCmdDrawIndirect* pPacket = (packet_vkCmdDrawIndirect*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndirect() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndirect() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            // No need to remap drawCount
            // No need to remap stride
            m_vkDeviceFuncs.CmdDrawIndirect(remappedcommandBuffer, remappedbuffer, pPacket->offset, pPacket->drawCount, pPacket->stride);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDrawIndexedIndirect: { 
            packet_vkCmdDrawIndexedIndirect* pPacket = (packet_vkCmdDrawIndexedIndirect*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexedIndirect() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexedIndirect() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            // No need to remap drawCount
            // No need to remap stride
            m_vkDeviceFuncs.CmdDrawIndexedIndirect(remappedcommandBuffer, remappedbuffer, pPacket->offset, pPacket->drawCount, pPacket->stride);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDispatch: { 
            packet_vkCmdDispatch* pPacket = (packet_vkCmdDispatch*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDispatch() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap groupCountX
            // No need to remap groupCountY
            // No need to remap groupCountZ
            m_vkDeviceFuncs.CmdDispatch(remappedcommandBuffer, pPacket->groupCountX, pPacket->groupCountY, pPacket->groupCountZ);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDispatchIndirect: { 
            packet_vkCmdDispatchIndirect* pPacket = (packet_vkCmdDispatchIndirect*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDispatchIndirect() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDispatchIndirect() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            m_vkDeviceFuncs.CmdDispatchIndirect(remappedcommandBuffer, remappedbuffer, pPacket->offset);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdCopyBuffer: { 
            packet_vkCmdCopyBuffer* pPacket = (packet_vkCmdCopyBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedsrcBuffer = m_objMapper.remap_buffers(pPacket->srcBuffer);
            if (pPacket->srcBuffer != VK_NULL_HANDLE && remappedsrcBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappeddstBuffer = m_objMapper.remap_buffers(pPacket->dstBuffer);
            if (pPacket->dstBuffer != VK_NULL_HANDLE && remappeddstBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap regionCount
            // No need to remap pRegions
            m_vkDeviceFuncs.CmdCopyBuffer(remappedcommandBuffer, remappedsrcBuffer, remappeddstBuffer, pPacket->regionCount, pPacket->pRegions);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdCopyImage: { 
            packet_vkCmdCopyImage* pPacket = (packet_vkCmdCopyImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedsrcImage = m_objMapper.remap_images(pPacket->srcImage);
            if (pPacket->srcImage != VK_NULL_HANDLE && remappedsrcImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcImageLayout
            VkImage remappeddstImage = m_objMapper.remap_images(pPacket->dstImage);
            if (pPacket->dstImage != VK_NULL_HANDLE && remappeddstImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstImageLayout
            // No need to remap regionCount
            // No need to remap pRegions
            m_vkDeviceFuncs.CmdCopyImage(remappedcommandBuffer, remappedsrcImage, pPacket->srcImageLayout, remappeddstImage, pPacket->dstImageLayout, pPacket->regionCount, pPacket->pRegions);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBlitImage: { 
            packet_vkCmdBlitImage* pPacket = (packet_vkCmdBlitImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBlitImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedsrcImage = m_objMapper.remap_images(pPacket->srcImage);
            if (pPacket->srcImage != VK_NULL_HANDLE && remappedsrcImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBlitImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcImageLayout
            VkImage remappeddstImage = m_objMapper.remap_images(pPacket->dstImage);
            if (pPacket->dstImage != VK_NULL_HANDLE && remappeddstImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBlitImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstImageLayout
            // No need to remap regionCount
            // No need to remap pRegions
            // No need to remap filter
            m_vkDeviceFuncs.CmdBlitImage(remappedcommandBuffer, remappedsrcImage, pPacket->srcImageLayout, remappeddstImage, pPacket->dstImageLayout, pPacket->regionCount, pPacket->pRegions, pPacket->filter);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdCopyBufferToImage: { 
            packet_vkCmdCopyBufferToImage* pPacket = (packet_vkCmdCopyBufferToImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBufferToImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedsrcBuffer = m_objMapper.remap_buffers(pPacket->srcBuffer);
            if (pPacket->srcBuffer != VK_NULL_HANDLE && remappedsrcBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBufferToImage() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappeddstImage = m_objMapper.remap_images(pPacket->dstImage);
            if (pPacket->dstImage != VK_NULL_HANDLE && remappeddstImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyBufferToImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstImageLayout
            // No need to remap regionCount
            // No need to remap pRegions
            m_vkDeviceFuncs.CmdCopyBufferToImage(remappedcommandBuffer, remappedsrcBuffer, remappeddstImage, pPacket->dstImageLayout, pPacket->regionCount, pPacket->pRegions);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdCopyImageToBuffer: { 
            packet_vkCmdCopyImageToBuffer* pPacket = (packet_vkCmdCopyImageToBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImageToBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedsrcImage = m_objMapper.remap_images(pPacket->srcImage);
            if (pPacket->srcImage != VK_NULL_HANDLE && remappedsrcImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImageToBuffer() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcImageLayout
            VkBuffer remappeddstBuffer = m_objMapper.remap_buffers(pPacket->dstBuffer);
            if (pPacket->dstBuffer != VK_NULL_HANDLE && remappeddstBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyImageToBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap regionCount
            // No need to remap pRegions
            m_vkDeviceFuncs.CmdCopyImageToBuffer(remappedcommandBuffer, remappedsrcImage, pPacket->srcImageLayout, remappeddstBuffer, pPacket->regionCount, pPacket->pRegions);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdUpdateBuffer: { 
            packet_vkCmdUpdateBuffer* pPacket = (packet_vkCmdUpdateBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdUpdateBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappeddstBuffer = m_objMapper.remap_buffers(pPacket->dstBuffer);
            if (pPacket->dstBuffer != VK_NULL_HANDLE && remappeddstBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdUpdateBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstOffset
            // No need to remap dataSize
            // No need to remap pData
            m_vkDeviceFuncs.CmdUpdateBuffer(remappedcommandBuffer, remappeddstBuffer, pPacket->dstOffset, pPacket->dataSize, pPacket->pData);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdFillBuffer: { 
            packet_vkCmdFillBuffer* pPacket = (packet_vkCmdFillBuffer*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdFillBuffer() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappeddstBuffer = m_objMapper.remap_buffers(pPacket->dstBuffer);
            if (pPacket->dstBuffer != VK_NULL_HANDLE && remappeddstBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdFillBuffer() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstOffset
            // No need to remap size
            // No need to remap data
            m_vkDeviceFuncs.CmdFillBuffer(remappedcommandBuffer, remappeddstBuffer, pPacket->dstOffset, pPacket->size, pPacket->data);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdClearColorImage: { 
            packet_vkCmdClearColorImage* pPacket = (packet_vkCmdClearColorImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdClearColorImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedimage = m_objMapper.remap_images(pPacket->image);
            if (pPacket->image != VK_NULL_HANDLE && remappedimage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdClearColorImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap imageLayout
            // No need to remap pColor
            // No need to remap rangeCount
            // No need to remap pRanges
            m_vkDeviceFuncs.CmdClearColorImage(remappedcommandBuffer, remappedimage, pPacket->imageLayout, pPacket->pColor, pPacket->rangeCount, pPacket->pRanges);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdClearDepthStencilImage: { 
            packet_vkCmdClearDepthStencilImage* pPacket = (packet_vkCmdClearDepthStencilImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdClearDepthStencilImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedimage = m_objMapper.remap_images(pPacket->image);
            if (pPacket->image != VK_NULL_HANDLE && remappedimage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdClearDepthStencilImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap imageLayout
            // No need to remap pDepthStencil
            // No need to remap rangeCount
            // No need to remap pRanges
            m_vkDeviceFuncs.CmdClearDepthStencilImage(remappedcommandBuffer, remappedimage, pPacket->imageLayout, pPacket->pDepthStencil, pPacket->rangeCount, pPacket->pRanges);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdClearAttachments: { 
            packet_vkCmdClearAttachments* pPacket = (packet_vkCmdClearAttachments*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdClearAttachments() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap attachmentCount
            // No need to remap pAttachments
            // No need to remap rectCount
            // No need to remap pRects
            m_vkDeviceFuncs.CmdClearAttachments(remappedcommandBuffer, pPacket->attachmentCount, pPacket->pAttachments, pPacket->rectCount, pPacket->pRects);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdResolveImage: { 
            packet_vkCmdResolveImage* pPacket = (packet_vkCmdResolveImage*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResolveImage() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkImage remappedsrcImage = m_objMapper.remap_images(pPacket->srcImage);
            if (pPacket->srcImage != VK_NULL_HANDLE && remappedsrcImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResolveImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcImageLayout
            VkImage remappeddstImage = m_objMapper.remap_images(pPacket->dstImage);
            if (pPacket->dstImage != VK_NULL_HANDLE && remappeddstImage == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResolveImage() due to invalid remapped VkImage.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstImageLayout
            // No need to remap regionCount
            // No need to remap pRegions
            m_vkDeviceFuncs.CmdResolveImage(remappedcommandBuffer, remappedsrcImage, pPacket->srcImageLayout, remappeddstImage, pPacket->dstImageLayout, pPacket->regionCount, pPacket->pRegions);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetEvent: { 
            packet_vkCmdSetEvent* pPacket = (packet_vkCmdSetEvent*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetEvent() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetEvent() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap stageMask
            m_vkDeviceFuncs.CmdSetEvent(remappedcommandBuffer, remappedevent, pPacket->stageMask);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdResetEvent: { 
            packet_vkCmdResetEvent* pPacket = (packet_vkCmdResetEvent*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResetEvent() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkEvent remappedevent = m_objMapper.remap_events(pPacket->event);
            if (pPacket->event != VK_NULL_HANDLE && remappedevent == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResetEvent() due to invalid remapped VkEvent.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap stageMask
            m_vkDeviceFuncs.CmdResetEvent(remappedcommandBuffer, remappedevent, pPacket->stageMask);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdWaitEvents: { 
            packet_vkCmdWaitEvents* pPacket = (packet_vkCmdWaitEvents*)(packet->pBody);
            manually_replay_vkCmdWaitEvents(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdPipelineBarrier: { 
            packet_vkCmdPipelineBarrier* pPacket = (packet_vkCmdPipelineBarrier*)(packet->pBody);
            manually_replay_vkCmdPipelineBarrier(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBeginQuery: { 
            packet_vkCmdBeginQuery* pPacket = (packet_vkCmdBeginQuery*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBeginQuery() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdBeginQuery() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap query
            // No need to remap flags
            m_vkDeviceFuncs.CmdBeginQuery(remappedcommandBuffer, remappedqueryPool, pPacket->query, pPacket->flags);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdEndQuery: { 
            packet_vkCmdEndQuery* pPacket = (packet_vkCmdEndQuery*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdEndQuery() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdEndQuery() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap query
            m_vkDeviceFuncs.CmdEndQuery(remappedcommandBuffer, remappedqueryPool, pPacket->query);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdResetQueryPool: { 
            packet_vkCmdResetQueryPool* pPacket = (packet_vkCmdResetQueryPool*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResetQueryPool() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdResetQueryPool() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstQuery
            // No need to remap queryCount
            m_vkDeviceFuncs.CmdResetQueryPool(remappedcommandBuffer, remappedqueryPool, pPacket->firstQuery, pPacket->queryCount);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdWriteTimestamp: { 
            packet_vkCmdWriteTimestamp* pPacket = (packet_vkCmdWriteTimestamp*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdWriteTimestamp() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pipelineStage
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdWriteTimestamp() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap query
            m_vkDeviceFuncs.CmdWriteTimestamp(remappedcommandBuffer, pPacket->pipelineStage, remappedqueryPool, pPacket->query);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdCopyQueryPoolResults: { 
            packet_vkCmdCopyQueryPoolResults* pPacket = (packet_vkCmdCopyQueryPoolResults*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyQueryPoolResults() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkQueryPool remappedqueryPool = m_objMapper.remap_querypools(pPacket->queryPool);
            if (pPacket->queryPool != VK_NULL_HANDLE && remappedqueryPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyQueryPoolResults() due to invalid remapped VkQueryPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstQuery
            // No need to remap queryCount
            VkBuffer remappeddstBuffer = m_objMapper.remap_buffers(pPacket->dstBuffer);
            if (pPacket->dstBuffer != VK_NULL_HANDLE && remappeddstBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdCopyQueryPoolResults() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dstOffset
            // No need to remap stride
            // No need to remap flags
            m_vkDeviceFuncs.CmdCopyQueryPoolResults(remappedcommandBuffer, remappedqueryPool, pPacket->firstQuery, pPacket->queryCount, remappeddstBuffer, pPacket->dstOffset, pPacket->stride, pPacket->flags);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdPushConstants: { 
            packet_vkCmdPushConstants* pPacket = (packet_vkCmdPushConstants*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdPushConstants() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipelineLayout remappedlayout = m_objMapper.remap_pipelinelayouts(pPacket->layout);
            if (pPacket->layout != VK_NULL_HANDLE && remappedlayout == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdPushConstants() due to invalid remapped VkPipelineLayout.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap stageFlags
            // No need to remap offset
            // No need to remap size
            // No need to remap pValues
            m_vkDeviceFuncs.CmdPushConstants(remappedcommandBuffer, remappedlayout, pPacket->stageFlags, pPacket->offset, pPacket->size, pPacket->pValues);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdBeginRenderPass: { 
            packet_vkCmdBeginRenderPass* pPacket = (packet_vkCmdBeginRenderPass*)(packet->pBody);
            manually_replay_vkCmdBeginRenderPass(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdNextSubpass: { 
            packet_vkCmdNextSubpass* pPacket = (packet_vkCmdNextSubpass*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdNextSubpass() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap contents
            m_vkDeviceFuncs.CmdNextSubpass(remappedcommandBuffer, pPacket->contents);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdEndRenderPass: { 
            packet_vkCmdEndRenderPass* pPacket = (packet_vkCmdEndRenderPass*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdEndRenderPass() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            m_vkDeviceFuncs.CmdEndRenderPass(remappedcommandBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdExecuteCommands: { 
            packet_vkCmdExecuteCommands* pPacket = (packet_vkCmdExecuteCommands*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdExecuteCommands() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap commandBufferCount
            VkCommandBuffer *remappedpCommandBuffers = new VkCommandBuffer[pPacket->commandBufferCount];
            for (uint32_t i = 0; i < pPacket->commandBufferCount; i++) {
                remappedpCommandBuffers[i] = m_objMapper.remap_commandbuffers(pPacket->pCommandBuffers[i]);
                if (pPacket->pCommandBuffers[i] != VK_NULL_HANDLE && remappedpCommandBuffers[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in CmdExecuteCommands() due to invalid remapped VkCommandBuffer.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            m_vkDeviceFuncs.CmdExecuteCommands(remappedcommandBuffer, pPacket->commandBufferCount, remappedpCommandBuffers);
            delete[] remappedpCommandBuffers;
            break;
        }
        case VKTRACE_TPI_VK_vkDestroySurfaceKHR: { 
            packet_vkDestroySurfaceKHR* pPacket = (packet_vkDestroySurfaceKHR*)(packet->pBody);
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySurfaceKHR() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSurfaceKHR remappedsurface = m_objMapper.remap_surfacekhrs(pPacket->surface);
            if (pPacket->surface != VK_NULL_HANDLE && remappedsurface == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySurfaceKHR() due to invalid remapped VkSurfaceKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkFuncs.DestroySurfaceKHR(remappedinstance, remappedsurface, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceSupportKHR: { 
            packet_vkGetPhysicalDeviceSurfaceSupportKHR* pPacket = (packet_vkGetPhysicalDeviceSurfaceSupportKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetPhysicalDeviceSurfaceSupportKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceSupportKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceCapabilitiesKHR: { 
            packet_vkGetPhysicalDeviceSurfaceCapabilitiesKHR* pPacket = (packet_vkGetPhysicalDeviceSurfaceCapabilitiesKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetPhysicalDeviceSurfaceCapabilitiesKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceCapabilitiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceFormatsKHR: { 
            packet_vkGetPhysicalDeviceSurfaceFormatsKHR* pPacket = (packet_vkGetPhysicalDeviceSurfaceFormatsKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetPhysicalDeviceSurfaceFormatsKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceFormatsKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfacePresentModesKHR: { 
            packet_vkGetPhysicalDeviceSurfacePresentModesKHR* pPacket = (packet_vkGetPhysicalDeviceSurfacePresentModesKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetPhysicalDeviceSurfacePresentModesKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfacePresentModesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateSwapchainKHR: { 
            packet_vkCreateSwapchainKHR* pPacket = (packet_vkCreateSwapchainKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateSwapchainKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateSwapchainKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroySwapchainKHR: { 
            packet_vkDestroySwapchainKHR* pPacket = (packet_vkDestroySwapchainKHR*)(packet->pBody);
            manually_replay_vkDestroySwapchainKHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetSwapchainImagesKHR: { 
            packet_vkGetSwapchainImagesKHR* pPacket = (packet_vkGetSwapchainImagesKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetSwapchainImagesKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetSwapchainImagesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkAcquireNextImageKHR: { 
            packet_vkAcquireNextImageKHR* pPacket = (packet_vkAcquireNextImageKHR*)(packet->pBody);
            uint32_t local_pImageIndex;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireNextImageKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSwapchainKHR remappedswapchain = m_objMapper.remap_swapchainkhrs(pPacket->swapchain);
            if (pPacket->swapchain != VK_NULL_HANDLE && remappedswapchain == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireNextImageKHR() due to invalid remapped VkSwapchainKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap timeout
            VkSemaphore remappedsemaphore = m_objMapper.remap_semaphores(pPacket->semaphore);
            if (pPacket->semaphore != VK_NULL_HANDLE && remappedsemaphore == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireNextImageKHR() due to invalid remapped VkSemaphore.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkFence remappedfence = m_objMapper.remap_fences(pPacket->fence);
            if (pPacket->fence != VK_NULL_HANDLE && remappedfence == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireNextImageKHR() due to invalid remapped VkFence.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.AcquireNextImageKHR(remappeddevice, remappedswapchain, pPacket->timeout, remappedsemaphore, remappedfence, &local_pImageIndex);
            m_objMapper.add_to_pImageIndex_map(*(pPacket->pImageIndex), local_pImageIndex);
            CHECK_RETURN_VALUE(vkAcquireNextImageKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkQueuePresentKHR: { 
            packet_vkQueuePresentKHR* pPacket = (packet_vkQueuePresentKHR*)(packet->pBody);
            replayResult = manually_replay_vkQueuePresentKHR(pPacket);
            CHECK_RETURN_VALUE(vkQueuePresentKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceDisplayPropertiesKHR: { 
            packet_vkGetPhysicalDeviceDisplayPropertiesKHR* pPacket = (packet_vkGetPhysicalDeviceDisplayPropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceDisplayPropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.GetPhysicalDeviceDisplayPropertiesKHR(remappedphysicalDevice, pPacket->pPropertyCount, pPacket->pProperties);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceDisplayPropertiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceDisplayPlanePropertiesKHR: { 
            packet_vkGetPhysicalDeviceDisplayPlanePropertiesKHR* pPacket = (packet_vkGetPhysicalDeviceDisplayPlanePropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceDisplayPlanePropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.GetPhysicalDeviceDisplayPlanePropertiesKHR(remappedphysicalDevice, pPacket->pPropertyCount, pPacket->pProperties);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceDisplayPlanePropertiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDisplayPlaneSupportedDisplaysKHR: { 
            packet_vkGetDisplayPlaneSupportedDisplaysKHR* pPacket = (packet_vkGetDisplayPlaneSupportedDisplaysKHR*)(packet->pBody);
            replayResult = manually_replay_vkGetDisplayPlaneSupportedDisplaysKHR(pPacket);
            CHECK_RETURN_VALUE(vkGetDisplayPlaneSupportedDisplaysKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDisplayModePropertiesKHR: { 
            packet_vkGetDisplayModePropertiesKHR* pPacket = (packet_vkGetDisplayModePropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDisplayModePropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDisplayKHR remappeddisplay = m_objMapper.remap_displaykhrs(pPacket->display);
            if (pPacket->display != VK_NULL_HANDLE && remappeddisplay == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDisplayModePropertiesKHR() due to invalid remapped VkDisplayKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPropertyCount
            // No need to remap pProperties
            replayResult = m_vkFuncs.GetDisplayModePropertiesKHR(remappedphysicalDevice, remappeddisplay, pPacket->pPropertyCount, pPacket->pProperties);
            CHECK_RETURN_VALUE(vkGetDisplayModePropertiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDisplayModeKHR: { 
            packet_vkCreateDisplayModeKHR* pPacket = (packet_vkCreateDisplayModeKHR*)(packet->pBody);
            VkDisplayModeKHR local_pMode;
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateDisplayModeKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDisplayKHR remappeddisplay = m_objMapper.remap_displaykhrs(pPacket->display);
            if (pPacket->display != VK_NULL_HANDLE && remappeddisplay == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateDisplayModeKHR() due to invalid remapped VkDisplayKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkFuncs.CreateDisplayModeKHR(remappedphysicalDevice, remappeddisplay, pPacket->pCreateInfo, pPacket->pAllocator, &local_pMode);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_displaymodekhrs_map(*(pPacket->pMode), local_pMode);
            }
            CHECK_RETURN_VALUE(vkCreateDisplayModeKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDisplayPlaneCapabilitiesKHR: { 
            packet_vkGetDisplayPlaneCapabilitiesKHR* pPacket = (packet_vkGetDisplayPlaneCapabilitiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDisplayPlaneCapabilitiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDisplayModeKHR remappedmode = m_objMapper.remap_displaymodekhrs(pPacket->mode);
            if (pPacket->mode != VK_NULL_HANDLE && remappedmode == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDisplayPlaneCapabilitiesKHR() due to invalid remapped VkDisplayModeKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap planeIndex
            // No need to remap pCapabilities
            replayResult = m_vkFuncs.GetDisplayPlaneCapabilitiesKHR(remappedphysicalDevice, remappedmode, pPacket->planeIndex, pPacket->pCapabilities);
            CHECK_RETURN_VALUE(vkGetDisplayPlaneCapabilitiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDisplayPlaneSurfaceKHR: { 
            packet_vkCreateDisplayPlaneSurfaceKHR* pPacket = (packet_vkCreateDisplayPlaneSurfaceKHR*)(packet->pBody);
            VkSurfaceKHR local_pSurface;
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateDisplayPlaneSurfaceKHR() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkFuncs.CreateDisplayPlaneSurfaceKHR(remappedinstance, pPacket->pCreateInfo, pPacket->pAllocator, &local_pSurface);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_surfacekhrs_map(*(pPacket->pSurface), local_pSurface);
            }
            CHECK_RETURN_VALUE(vkCreateDisplayPlaneSurfaceKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateSharedSwapchainsKHR: { 
            packet_vkCreateSharedSwapchainsKHR* pPacket = (packet_vkCreateSharedSwapchainsKHR*)(packet->pBody);
            VkSwapchainKHR local_pSwapchains;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateSharedSwapchainsKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap swapchainCount
            // No need to remap pCreateInfos
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateSharedSwapchainsKHR(remappeddevice, pPacket->swapchainCount, pPacket->pCreateInfos, pPacket->pAllocator, &local_pSwapchains);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_swapchainkhrs_map(*(pPacket->pSwapchains), local_pSwapchains);
            }
            CHECK_RETURN_VALUE(vkCreateSharedSwapchainsKHR);
            break;
        }
#ifdef VK_USE_PLATFORM_XLIB_KHR
        case VKTRACE_TPI_VK_vkCreateXlibSurfaceKHR: { 
            packet_vkCreateXlibSurfaceKHR* pPacket = (packet_vkCreateXlibSurfaceKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateXlibSurfaceKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateXlibSurfaceKHR);
            break;
        }
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceXlibPresentationSupportKHR: { 
            packet_vkGetPhysicalDeviceXlibPresentationSupportKHR* pPacket = (packet_vkGetPhysicalDeviceXlibPresentationSupportKHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceXlibPresentationSupportKHR(pPacket);
            break;
        }
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
        case VKTRACE_TPI_VK_vkCreateXcbSurfaceKHR: { 
            packet_vkCreateXcbSurfaceKHR* pPacket = (packet_vkCreateXcbSurfaceKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateXcbSurfaceKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateXcbSurfaceKHR);
            break;
        }
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceXcbPresentationSupportKHR: { 
            packet_vkGetPhysicalDeviceXcbPresentationSupportKHR* pPacket = (packet_vkGetPhysicalDeviceXcbPresentationSupportKHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceXcbPresentationSupportKHR(pPacket);
            break;
        }
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
        case VKTRACE_TPI_VK_vkCreateWaylandSurfaceKHR: { 
            packet_vkCreateWaylandSurfaceKHR* pPacket = (packet_vkCreateWaylandSurfaceKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateWaylandSurfaceKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateWaylandSurfaceKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceWaylandPresentationSupportKHR: { 
            packet_vkGetPhysicalDeviceWaylandPresentationSupportKHR* pPacket = (packet_vkGetPhysicalDeviceWaylandPresentationSupportKHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceWaylandPresentationSupportKHR(pPacket);
            break;
        }
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
        case VKTRACE_TPI_VK_vkCreateAndroidSurfaceKHR: { 
            packet_vkCreateAndroidSurfaceKHR* pPacket = (packet_vkCreateAndroidSurfaceKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateAndroidSurfaceKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateAndroidSurfaceKHR);
            break;
        }
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkCreateWin32SurfaceKHR: { 
            packet_vkCreateWin32SurfaceKHR* pPacket = (packet_vkCreateWin32SurfaceKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateWin32SurfaceKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateWin32SurfaceKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceWin32PresentationSupportKHR: { 
            packet_vkGetPhysicalDeviceWin32PresentationSupportKHR* pPacket = (packet_vkGetPhysicalDeviceWin32PresentationSupportKHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceWin32PresentationSupportKHR(pPacket);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceFeatures2KHR: { 
            packet_vkGetPhysicalDeviceFeatures2KHR* pPacket = (packet_vkGetPhysicalDeviceFeatures2KHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceFeatures2KHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pFeatures
            m_vkFuncs.GetPhysicalDeviceFeatures2KHR(remappedphysicalDevice, pPacket->pFeatures);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceProperties2KHR: { 
            packet_vkGetPhysicalDeviceProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceProperties2KHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceProperties2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceFormatProperties2KHR: { 
            packet_vkGetPhysicalDeviceFormatProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceFormatProperties2KHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceFormatProperties2KHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap format
            // No need to remap pFormatProperties
            m_vkFuncs.GetPhysicalDeviceFormatProperties2KHR(remappedphysicalDevice, pPacket->format, pPacket->pFormatProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceImageFormatProperties2KHR: { 
            packet_vkGetPhysicalDeviceImageFormatProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceImageFormatProperties2KHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceImageFormatProperties2KHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pImageFormatInfo
            // No need to remap pImageFormatProperties
            replayResult = m_vkFuncs.GetPhysicalDeviceImageFormatProperties2KHR(remappedphysicalDevice, pPacket->pImageFormatInfo, pPacket->pImageFormatProperties);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceImageFormatProperties2KHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceQueueFamilyProperties2KHR: { 
            packet_vkGetPhysicalDeviceQueueFamilyProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceQueueFamilyProperties2KHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceQueueFamilyProperties2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceMemoryProperties2KHR: { 
            packet_vkGetPhysicalDeviceMemoryProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceMemoryProperties2KHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceMemoryProperties2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSparseImageFormatProperties2KHR: { 
            packet_vkGetPhysicalDeviceSparseImageFormatProperties2KHR* pPacket = (packet_vkGetPhysicalDeviceSparseImageFormatProperties2KHR*)(packet->pBody);
            manually_replay_vkGetPhysicalDeviceSparseImageFormatProperties2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkTrimCommandPoolKHR: { 
            packet_vkTrimCommandPoolKHR* pPacket = (packet_vkTrimCommandPoolKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in TrimCommandPoolKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkCommandPool remappedcommandPool = m_objMapper.remap_commandpools(pPacket->commandPool);
            if (pPacket->commandPool != VK_NULL_HANDLE && remappedcommandPool == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in TrimCommandPoolKHR() due to invalid remapped VkCommandPool.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap flags
            m_vkDeviceFuncs.TrimCommandPoolKHR(remappeddevice, remappedcommandPool, pPacket->flags);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceExternalBufferPropertiesKHR: { 
            packet_vkGetPhysicalDeviceExternalBufferPropertiesKHR* pPacket = (packet_vkGetPhysicalDeviceExternalBufferPropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceExternalBufferPropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pExternalBufferInfo
            // No need to remap pExternalBufferProperties
            m_vkFuncs.GetPhysicalDeviceExternalBufferPropertiesKHR(remappedphysicalDevice, pPacket->pExternalBufferInfo, pPacket->pExternalBufferProperties);
            break;
        }
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetMemoryWin32HandleKHR: { 
            packet_vkGetMemoryWin32HandleKHR* pPacket = (packet_vkGetMemoryWin32HandleKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryWin32HandleKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetWin32HandleInfo
            // No need to remap pHandle
            replayResult = m_vkDeviceFuncs.GetMemoryWin32HandleKHR(remappeddevice, pPacket->pGetWin32HandleInfo, pPacket->pHandle);
            CHECK_RETURN_VALUE(vkGetMemoryWin32HandleKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetMemoryWin32HandlePropertiesKHR: { 
            packet_vkGetMemoryWin32HandlePropertiesKHR* pPacket = (packet_vkGetMemoryWin32HandlePropertiesKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryWin32HandlePropertiesKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap handleType
            // No need to remap handle
            // No need to remap pMemoryWin32HandleProperties
            replayResult = m_vkDeviceFuncs.GetMemoryWin32HandlePropertiesKHR(remappeddevice, pPacket->handleType, pPacket->handle, pPacket->pMemoryWin32HandleProperties);
            CHECK_RETURN_VALUE(vkGetMemoryWin32HandlePropertiesKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetMemoryFdKHR: { 
            packet_vkGetMemoryFdKHR* pPacket = (packet_vkGetMemoryFdKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryFdKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetFdInfo
            // No need to remap pFd
            replayResult = m_vkDeviceFuncs.GetMemoryFdKHR(remappeddevice, pPacket->pGetFdInfo, pPacket->pFd);
            CHECK_RETURN_VALUE(vkGetMemoryFdKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetMemoryFdPropertiesKHR: { 
            packet_vkGetMemoryFdPropertiesKHR* pPacket = (packet_vkGetMemoryFdPropertiesKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryFdPropertiesKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap handleType
            // No need to remap fd
            // No need to remap pMemoryFdProperties
            replayResult = m_vkDeviceFuncs.GetMemoryFdPropertiesKHR(remappeddevice, pPacket->handleType, pPacket->fd, pPacket->pMemoryFdProperties);
            CHECK_RETURN_VALUE(vkGetMemoryFdPropertiesKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR: { 
            packet_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR* pPacket = (packet_vkGetPhysicalDeviceExternalSemaphorePropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceExternalSemaphorePropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pExternalSemaphoreInfo
            // No need to remap pExternalSemaphoreProperties
            m_vkFuncs.GetPhysicalDeviceExternalSemaphorePropertiesKHR(remappedphysicalDevice, pPacket->pExternalSemaphoreInfo, pPacket->pExternalSemaphoreProperties);
            break;
        }
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkImportSemaphoreWin32HandleKHR: { 
            packet_vkImportSemaphoreWin32HandleKHR* pPacket = (packet_vkImportSemaphoreWin32HandleKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ImportSemaphoreWin32HandleKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pImportSemaphoreWin32HandleInfo
            replayResult = m_vkDeviceFuncs.ImportSemaphoreWin32HandleKHR(remappeddevice, pPacket->pImportSemaphoreWin32HandleInfo);
            CHECK_RETURN_VALUE(vkImportSemaphoreWin32HandleKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetSemaphoreWin32HandleKHR: { 
            packet_vkGetSemaphoreWin32HandleKHR* pPacket = (packet_vkGetSemaphoreWin32HandleKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSemaphoreWin32HandleKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetWin32HandleInfo
            // No need to remap pHandle
            replayResult = m_vkDeviceFuncs.GetSemaphoreWin32HandleKHR(remappeddevice, pPacket->pGetWin32HandleInfo, pPacket->pHandle);
            CHECK_RETURN_VALUE(vkGetSemaphoreWin32HandleKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkImportSemaphoreFdKHR: { 
            packet_vkImportSemaphoreFdKHR* pPacket = (packet_vkImportSemaphoreFdKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ImportSemaphoreFdKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pImportSemaphoreFdInfo
            replayResult = m_vkDeviceFuncs.ImportSemaphoreFdKHR(remappeddevice, pPacket->pImportSemaphoreFdInfo);
            CHECK_RETURN_VALUE(vkImportSemaphoreFdKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetSemaphoreFdKHR: { 
            packet_vkGetSemaphoreFdKHR* pPacket = (packet_vkGetSemaphoreFdKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSemaphoreFdKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetFdInfo
            // No need to remap pFd
            replayResult = m_vkDeviceFuncs.GetSemaphoreFdKHR(remappeddevice, pPacket->pGetFdInfo, pPacket->pFd);
            CHECK_RETURN_VALUE(vkGetSemaphoreFdKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdPushDescriptorSetKHR: { 
            packet_vkCmdPushDescriptorSetKHR* pPacket = (packet_vkCmdPushDescriptorSetKHR*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdPushDescriptorSetKHR() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pipelineBindPoint
            VkPipelineLayout remappedlayout = m_objMapper.remap_pipelinelayouts(pPacket->layout);
            if (pPacket->layout != VK_NULL_HANDLE && remappedlayout == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdPushDescriptorSetKHR() due to invalid remapped VkPipelineLayout.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap set
            // No need to remap descriptorWriteCount
            // No need to remap pDescriptorWrites
            m_vkDeviceFuncs.CmdPushDescriptorSetKHR(remappedcommandBuffer, pPacket->pipelineBindPoint, remappedlayout, pPacket->set, pPacket->descriptorWriteCount, pPacket->pDescriptorWrites);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDescriptorUpdateTemplateKHR: { 
            packet_vkCreateDescriptorUpdateTemplateKHR* pPacket = (packet_vkCreateDescriptorUpdateTemplateKHR*)(packet->pBody);
            replayResult = manually_replay_vkCreateDescriptorUpdateTemplateKHR(pPacket);
            CHECK_RETURN_VALUE(vkCreateDescriptorUpdateTemplateKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyDescriptorUpdateTemplateKHR: { 
            packet_vkDestroyDescriptorUpdateTemplateKHR* pPacket = (packet_vkDestroyDescriptorUpdateTemplateKHR*)(packet->pBody);
            manually_replay_vkDestroyDescriptorUpdateTemplateKHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkUpdateDescriptorSetWithTemplateKHR: { 
            packet_vkUpdateDescriptorSetWithTemplateKHR* pPacket = (packet_vkUpdateDescriptorSetWithTemplateKHR*)(packet->pBody);
            manually_replay_vkUpdateDescriptorSetWithTemplateKHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdPushDescriptorSetWithTemplateKHR: { 
            packet_vkCmdPushDescriptorSetWithTemplateKHR* pPacket = (packet_vkCmdPushDescriptorSetWithTemplateKHR*)(packet->pBody);
            manually_replay_vkCmdPushDescriptorSetWithTemplateKHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetSwapchainStatusKHR: { 
            packet_vkGetSwapchainStatusKHR* pPacket = (packet_vkGetSwapchainStatusKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSwapchainStatusKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSwapchainKHR remappedswapchain = m_objMapper.remap_swapchainkhrs(pPacket->swapchain);
            if (pPacket->swapchain != VK_NULL_HANDLE && remappedswapchain == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSwapchainStatusKHR() due to invalid remapped VkSwapchainKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkDeviceFuncs.GetSwapchainStatusKHR(remappeddevice, remappedswapchain);
            CHECK_RETURN_VALUE(vkGetSwapchainStatusKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceExternalFencePropertiesKHR: { 
            packet_vkGetPhysicalDeviceExternalFencePropertiesKHR* pPacket = (packet_vkGetPhysicalDeviceExternalFencePropertiesKHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceExternalFencePropertiesKHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pExternalFenceInfo
            // No need to remap pExternalFenceProperties
            m_vkFuncs.GetPhysicalDeviceExternalFencePropertiesKHR(remappedphysicalDevice, pPacket->pExternalFenceInfo, pPacket->pExternalFenceProperties);
            break;
        }
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkImportFenceWin32HandleKHR: { 
            packet_vkImportFenceWin32HandleKHR* pPacket = (packet_vkImportFenceWin32HandleKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ImportFenceWin32HandleKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pImportFenceWin32HandleInfo
            replayResult = m_vkDeviceFuncs.ImportFenceWin32HandleKHR(remappeddevice, pPacket->pImportFenceWin32HandleInfo);
            CHECK_RETURN_VALUE(vkImportFenceWin32HandleKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetFenceWin32HandleKHR: { 
            packet_vkGetFenceWin32HandleKHR* pPacket = (packet_vkGetFenceWin32HandleKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetFenceWin32HandleKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetWin32HandleInfo
            // No need to remap pHandle
            replayResult = m_vkDeviceFuncs.GetFenceWin32HandleKHR(remappeddevice, pPacket->pGetWin32HandleInfo, pPacket->pHandle);
            CHECK_RETURN_VALUE(vkGetFenceWin32HandleKHR);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkImportFenceFdKHR: { 
            packet_vkImportFenceFdKHR* pPacket = (packet_vkImportFenceFdKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ImportFenceFdKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pImportFenceFdInfo
            replayResult = m_vkDeviceFuncs.ImportFenceFdKHR(remappeddevice, pPacket->pImportFenceFdInfo);
            CHECK_RETURN_VALUE(vkImportFenceFdKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetFenceFdKHR: { 
            packet_vkGetFenceFdKHR* pPacket = (packet_vkGetFenceFdKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetFenceFdKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pGetFdInfo
            // No need to remap pFd
            replayResult = m_vkDeviceFuncs.GetFenceFdKHR(remappeddevice, pPacket->pGetFdInfo, pPacket->pFd);
            CHECK_RETURN_VALUE(vkGetFenceFdKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceCapabilities2KHR: { 
            packet_vkGetPhysicalDeviceSurfaceCapabilities2KHR* pPacket = (packet_vkGetPhysicalDeviceSurfaceCapabilities2KHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceSurfaceCapabilities2KHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSurfaceInfo
            // No need to remap pSurfaceCapabilities
            replayResult = m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2KHR(remappedphysicalDevice, pPacket->pSurfaceInfo, pPacket->pSurfaceCapabilities);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceCapabilities2KHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceFormats2KHR: { 
            packet_vkGetPhysicalDeviceSurfaceFormats2KHR* pPacket = (packet_vkGetPhysicalDeviceSurfaceFormats2KHR*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceSurfaceFormats2KHR() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSurfaceInfo
            // No need to remap pSurfaceFormatCount
            // No need to remap pSurfaceFormats
            replayResult = m_vkFuncs.GetPhysicalDeviceSurfaceFormats2KHR(remappedphysicalDevice, pPacket->pSurfaceInfo, pPacket->pSurfaceFormatCount, pPacket->pSurfaceFormats);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceFormats2KHR);
            break;
        }
        case VKTRACE_TPI_VK_vkGetImageMemoryRequirements2KHR: { 
            packet_vkGetImageMemoryRequirements2KHR* pPacket = (packet_vkGetImageMemoryRequirements2KHR*)(packet->pBody);
            manually_replay_vkGetImageMemoryRequirements2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetBufferMemoryRequirements2KHR: { 
            packet_vkGetBufferMemoryRequirements2KHR* pPacket = (packet_vkGetBufferMemoryRequirements2KHR*)(packet->pBody);
            manually_replay_vkGetBufferMemoryRequirements2KHR(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkGetImageSparseMemoryRequirements2KHR: { 
            packet_vkGetImageSparseMemoryRequirements2KHR* pPacket = (packet_vkGetImageSparseMemoryRequirements2KHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetImageSparseMemoryRequirements2KHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pInfo
            // No need to remap pSparseMemoryRequirementCount
            // No need to remap pSparseMemoryRequirements
            m_vkDeviceFuncs.GetImageSparseMemoryRequirements2KHR(remappeddevice, pPacket->pInfo, pPacket->pSparseMemoryRequirementCount, pPacket->pSparseMemoryRequirements);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateSamplerYcbcrConversionKHR: { 
            packet_vkCreateSamplerYcbcrConversionKHR* pPacket = (packet_vkCreateSamplerYcbcrConversionKHR*)(packet->pBody);
            VkSamplerYcbcrConversionKHR local_pYcbcrConversion;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateSamplerYcbcrConversionKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateSamplerYcbcrConversionKHR(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pYcbcrConversion);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_samplerycbcrconversionkhrs_map(*(pPacket->pYcbcrConversion), local_pYcbcrConversion);
            }
            CHECK_RETURN_VALUE(vkCreateSamplerYcbcrConversionKHR);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroySamplerYcbcrConversionKHR: { 
            packet_vkDestroySamplerYcbcrConversionKHR* pPacket = (packet_vkDestroySamplerYcbcrConversionKHR*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySamplerYcbcrConversionKHR() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSamplerYcbcrConversionKHR remappedycbcrConversion = m_objMapper.remap_samplerycbcrconversionkhrs(pPacket->ycbcrConversion);
            if (pPacket->ycbcrConversion != VK_NULL_HANDLE && remappedycbcrConversion == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroySamplerYcbcrConversionKHR() due to invalid remapped VkSamplerYcbcrConversionKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroySamplerYcbcrConversionKHR(remappeddevice, remappedycbcrConversion, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkBindBufferMemory2KHR: { 
            packet_vkBindBufferMemory2KHR* pPacket = (packet_vkBindBufferMemory2KHR*)(packet->pBody);
            replayResult = manually_replay_vkBindBufferMemory2KHR(pPacket);
            CHECK_RETURN_VALUE(vkBindBufferMemory2KHR);
            break;
        }
        case VKTRACE_TPI_VK_vkBindImageMemory2KHR: { 
            packet_vkBindImageMemory2KHR* pPacket = (packet_vkBindImageMemory2KHR*)(packet->pBody);
            replayResult = manually_replay_vkBindImageMemory2KHR(pPacket);
            CHECK_RETURN_VALUE(vkBindImageMemory2KHR);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateDebugReportCallbackEXT: { 
            packet_vkCreateDebugReportCallbackEXT* pPacket = (packet_vkCreateDebugReportCallbackEXT*)(packet->pBody);
            replayResult = manually_replay_vkCreateDebugReportCallbackEXT(pPacket);
            CHECK_RETURN_VALUE(vkCreateDebugReportCallbackEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyDebugReportCallbackEXT: { 
            packet_vkDestroyDebugReportCallbackEXT* pPacket = (packet_vkDestroyDebugReportCallbackEXT*)(packet->pBody);
            manually_replay_vkDestroyDebugReportCallbackEXT(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkDebugReportMessageEXT: { 
            packet_vkDebugReportMessageEXT* pPacket = (packet_vkDebugReportMessageEXT*)(packet->pBody);
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DebugReportMessageEXT() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap flags
            // No need to remap objectType
            // No need to remap object
            // No need to remap location
            // No need to remap messageCode
            // No need to remap pLayerPrefix
            // No need to remap pMessage
            m_vkFuncs.DebugReportMessageEXT(remappedinstance, pPacket->flags, pPacket->objectType, pPacket->object, pPacket->location, pPacket->messageCode, pPacket->pLayerPrefix, pPacket->pMessage);
            break;
        }
        case VKTRACE_TPI_VK_vkDebugMarkerSetObjectTagEXT: { 
            packet_vkDebugMarkerSetObjectTagEXT* pPacket = (packet_vkDebugMarkerSetObjectTagEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DebugMarkerSetObjectTagEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pTagInfo
            replayResult = m_vkDeviceFuncs.DebugMarkerSetObjectTagEXT(remappeddevice, pPacket->pTagInfo);
            CHECK_RETURN_VALUE(vkDebugMarkerSetObjectTagEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkDebugMarkerSetObjectNameEXT: { 
            packet_vkDebugMarkerSetObjectNameEXT* pPacket = (packet_vkDebugMarkerSetObjectNameEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DebugMarkerSetObjectNameEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pNameInfo
            replayResult = m_vkDeviceFuncs.DebugMarkerSetObjectNameEXT(remappeddevice, pPacket->pNameInfo);
            CHECK_RETURN_VALUE(vkDebugMarkerSetObjectNameEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDebugMarkerBeginEXT: { 
            packet_vkCmdDebugMarkerBeginEXT* pPacket = (packet_vkCmdDebugMarkerBeginEXT*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDebugMarkerBeginEXT() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pMarkerInfo
            m_vkDeviceFuncs.CmdDebugMarkerBeginEXT(remappedcommandBuffer, pPacket->pMarkerInfo);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDebugMarkerEndEXT: { 
            packet_vkCmdDebugMarkerEndEXT* pPacket = (packet_vkCmdDebugMarkerEndEXT*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDebugMarkerEndEXT() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            m_vkDeviceFuncs.CmdDebugMarkerEndEXT(remappedcommandBuffer);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDebugMarkerInsertEXT: { 
            packet_vkCmdDebugMarkerInsertEXT* pPacket = (packet_vkCmdDebugMarkerInsertEXT*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDebugMarkerInsertEXT() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pMarkerInfo
            m_vkDeviceFuncs.CmdDebugMarkerInsertEXT(remappedcommandBuffer, pPacket->pMarkerInfo);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDrawIndirectCountAMD: { 
            packet_vkCmdDrawIndirectCountAMD* pPacket = (packet_vkCmdDrawIndirectCountAMD*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndirectCountAMD() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndirectCountAMD() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            VkBuffer remappedcountBuffer = m_objMapper.remap_buffers(pPacket->countBuffer);
            if (pPacket->countBuffer != VK_NULL_HANDLE && remappedcountBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndirectCountAMD() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap countBufferOffset
            // No need to remap maxDrawCount
            // No need to remap stride
            m_vkDeviceFuncs.CmdDrawIndirectCountAMD(remappedcommandBuffer, remappedbuffer, pPacket->offset, remappedcountBuffer, pPacket->countBufferOffset, pPacket->maxDrawCount, pPacket->stride);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDrawIndexedIndirectCountAMD: { 
            packet_vkCmdDrawIndexedIndirectCountAMD* pPacket = (packet_vkCmdDrawIndexedIndirectCountAMD*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexedIndirectCountAMD() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkBuffer remappedbuffer = m_objMapper.remap_buffers(pPacket->buffer);
            if (pPacket->buffer != VK_NULL_HANDLE && remappedbuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexedIndirectCountAMD() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap offset
            VkBuffer remappedcountBuffer = m_objMapper.remap_buffers(pPacket->countBuffer);
            if (pPacket->countBuffer != VK_NULL_HANDLE && remappedcountBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDrawIndexedIndirectCountAMD() due to invalid remapped VkBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap countBufferOffset
            // No need to remap maxDrawCount
            // No need to remap stride
            m_vkDeviceFuncs.CmdDrawIndexedIndirectCountAMD(remappedcommandBuffer, remappedbuffer, pPacket->offset, remappedcountBuffer, pPacket->countBufferOffset, pPacket->maxDrawCount, pPacket->stride);
            break;
        }
        case VKTRACE_TPI_VK_vkGetShaderInfoAMD: { 
            packet_vkGetShaderInfoAMD* pPacket = (packet_vkGetShaderInfoAMD*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetShaderInfoAMD() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkPipeline remappedpipeline = m_objMapper.remap_pipelines(pPacket->pipeline);
            if (pPacket->pipeline != VK_NULL_HANDLE && remappedpipeline == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetShaderInfoAMD() due to invalid remapped VkPipeline.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap shaderStage
            // No need to remap infoType
            // No need to remap pInfoSize
            // No need to remap pInfo
            replayResult = m_vkDeviceFuncs.GetShaderInfoAMD(remappeddevice, remappedpipeline, pPacket->shaderStage, pPacket->infoType, pPacket->pInfoSize, pPacket->pInfo);
            CHECK_RETURN_VALUE(vkGetShaderInfoAMD);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceExternalImageFormatPropertiesNV: { 
            packet_vkGetPhysicalDeviceExternalImageFormatPropertiesNV* pPacket = (packet_vkGetPhysicalDeviceExternalImageFormatPropertiesNV*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceExternalImageFormatPropertiesNV() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap format
            // No need to remap type
            // No need to remap tiling
            // No need to remap usage
            // No need to remap flags
            // No need to remap externalHandleType
            // No need to remap pExternalImageFormatProperties
            replayResult = m_vkFuncs.GetPhysicalDeviceExternalImageFormatPropertiesNV(remappedphysicalDevice, pPacket->format, pPacket->type, pPacket->tiling, pPacket->usage, pPacket->flags, pPacket->externalHandleType, pPacket->pExternalImageFormatProperties);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceExternalImageFormatPropertiesNV);
            break;
        }
#ifdef VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetMemoryWin32HandleNV: { 
            packet_vkGetMemoryWin32HandleNV* pPacket = (packet_vkGetMemoryWin32HandleNV*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryWin32HandleNV() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDeviceMemory remappedmemory = m_objMapper.remap_devicememorys(pPacket->memory);
            if (pPacket->memory != VK_NULL_HANDLE && remappedmemory == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryWin32HandleNV() due to invalid remapped VkDeviceMemory.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap handleType
            // No need to remap pHandle
            replayResult = m_vkDeviceFuncs.GetMemoryWin32HandleNV(remappeddevice, remappedmemory, pPacket->handleType, pPacket->pHandle);
            CHECK_RETURN_VALUE(vkGetMemoryWin32HandleNV);
            break;
        }
#endif // VK_USE_PLATFORM_WIN32_KHR
        case VKTRACE_TPI_VK_vkGetDeviceGroupPeerMemoryFeaturesKHX: { 
            packet_vkGetDeviceGroupPeerMemoryFeaturesKHX* pPacket = (packet_vkGetDeviceGroupPeerMemoryFeaturesKHX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceGroupPeerMemoryFeaturesKHX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap heapIndex
            // No need to remap localDeviceIndex
            // No need to remap remoteDeviceIndex
            // No need to remap pPeerMemoryFeatures
            m_vkDeviceFuncs.GetDeviceGroupPeerMemoryFeaturesKHX(remappeddevice, pPacket->heapIndex, pPacket->localDeviceIndex, pPacket->remoteDeviceIndex, pPacket->pPeerMemoryFeatures);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetDeviceMaskKHX: { 
            packet_vkCmdSetDeviceMaskKHX* pPacket = (packet_vkCmdSetDeviceMaskKHX*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetDeviceMaskKHX() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap deviceMask
            m_vkDeviceFuncs.CmdSetDeviceMaskKHX(remappedcommandBuffer, pPacket->deviceMask);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdDispatchBaseKHX: { 
            packet_vkCmdDispatchBaseKHX* pPacket = (packet_vkCmdDispatchBaseKHX*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdDispatchBaseKHX() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap baseGroupX
            // No need to remap baseGroupY
            // No need to remap baseGroupZ
            // No need to remap groupCountX
            // No need to remap groupCountY
            // No need to remap groupCountZ
            m_vkDeviceFuncs.CmdDispatchBaseKHX(remappedcommandBuffer, pPacket->baseGroupX, pPacket->baseGroupY, pPacket->baseGroupZ, pPacket->groupCountX, pPacket->groupCountY, pPacket->groupCountZ);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDeviceGroupPresentCapabilitiesKHX: { 
            packet_vkGetDeviceGroupPresentCapabilitiesKHX* pPacket = (packet_vkGetDeviceGroupPresentCapabilitiesKHX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceGroupPresentCapabilitiesKHX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pDeviceGroupPresentCapabilities
            replayResult = m_vkDeviceFuncs.GetDeviceGroupPresentCapabilitiesKHX(remappeddevice, pPacket->pDeviceGroupPresentCapabilities);
            CHECK_RETURN_VALUE(vkGetDeviceGroupPresentCapabilitiesKHX);
            break;
        }
        case VKTRACE_TPI_VK_vkGetDeviceGroupSurfacePresentModesKHX: { 
            packet_vkGetDeviceGroupSurfacePresentModesKHX* pPacket = (packet_vkGetDeviceGroupSurfacePresentModesKHX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceGroupSurfacePresentModesKHX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSurfaceKHR remappedsurface = m_objMapper.remap_surfacekhrs(pPacket->surface);
            if (pPacket->surface != VK_NULL_HANDLE && remappedsurface == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetDeviceGroupSurfacePresentModesKHX() due to invalid remapped VkSurfaceKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pModes
            replayResult = m_vkDeviceFuncs.GetDeviceGroupSurfacePresentModesKHX(remappeddevice, remappedsurface, pPacket->pModes);
            CHECK_RETURN_VALUE(vkGetDeviceGroupSurfacePresentModesKHX);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDevicePresentRectanglesKHX: { 
            packet_vkGetPhysicalDevicePresentRectanglesKHX* pPacket = (packet_vkGetPhysicalDevicePresentRectanglesKHX*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDevicePresentRectanglesKHX() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSurfaceKHR remappedsurface = m_objMapper.remap_surfacekhrs(pPacket->surface);
            if (pPacket->surface != VK_NULL_HANDLE && remappedsurface == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDevicePresentRectanglesKHX() due to invalid remapped VkSurfaceKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pRectCount
            // No need to remap pRects
            replayResult = m_vkFuncs.GetPhysicalDevicePresentRectanglesKHX(remappedphysicalDevice, remappedsurface, pPacket->pRectCount, pPacket->pRects);
            CHECK_RETURN_VALUE(vkGetPhysicalDevicePresentRectanglesKHX);
            break;
        }
        case VKTRACE_TPI_VK_vkAcquireNextImage2KHX: { 
            packet_vkAcquireNextImage2KHX* pPacket = (packet_vkAcquireNextImage2KHX*)(packet->pBody);
            uint32_t local_pImageIndex;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireNextImage2KHX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAcquireInfo
            replayResult = m_vkDeviceFuncs.AcquireNextImage2KHX(remappeddevice, pPacket->pAcquireInfo, &local_pImageIndex);
            m_objMapper.add_to_pImageIndex_map(*(pPacket->pImageIndex), local_pImageIndex);
            CHECK_RETURN_VALUE(vkAcquireNextImage2KHX);
            break;
        }
        case VKTRACE_TPI_VK_vkEnumeratePhysicalDeviceGroupsKHX: { 
            packet_vkEnumeratePhysicalDeviceGroupsKHX* pPacket = (packet_vkEnumeratePhysicalDeviceGroupsKHX*)(packet->pBody);
            VkInstance remappedinstance = m_objMapper.remap_instances(pPacket->instance);
            if (pPacket->instance != VK_NULL_HANDLE && remappedinstance == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in EnumeratePhysicalDeviceGroupsKHX() due to invalid remapped VkInstance.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPhysicalDeviceGroupCount
            // No need to remap pPhysicalDeviceGroupProperties
            replayResult = m_vkFuncs.EnumeratePhysicalDeviceGroupsKHX(remappedinstance, pPacket->pPhysicalDeviceGroupCount, pPacket->pPhysicalDeviceGroupProperties);
            CHECK_RETURN_VALUE(vkEnumeratePhysicalDeviceGroupsKHX);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdProcessCommandsNVX: { 
            packet_vkCmdProcessCommandsNVX* pPacket = (packet_vkCmdProcessCommandsNVX*)(packet->pBody);
            manually_replay_vkCmdProcessCommandsNVX(pPacket);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdReserveSpaceForCommandsNVX: { 
            packet_vkCmdReserveSpaceForCommandsNVX* pPacket = (packet_vkCmdReserveSpaceForCommandsNVX*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdReserveSpaceForCommandsNVX() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pReserveSpaceInfo
            m_vkDeviceFuncs.CmdReserveSpaceForCommandsNVX(remappedcommandBuffer, pPacket->pReserveSpaceInfo);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateIndirectCommandsLayoutNVX: { 
            packet_vkCreateIndirectCommandsLayoutNVX* pPacket = (packet_vkCreateIndirectCommandsLayoutNVX*)(packet->pBody);
            replayResult = manually_replay_vkCreateIndirectCommandsLayoutNVX(pPacket);
            CHECK_RETURN_VALUE(vkCreateIndirectCommandsLayoutNVX);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyIndirectCommandsLayoutNVX: { 
            packet_vkDestroyIndirectCommandsLayoutNVX* pPacket = (packet_vkDestroyIndirectCommandsLayoutNVX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyIndirectCommandsLayoutNVX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkIndirectCommandsLayoutNVX remappedindirectCommandsLayout = m_objMapper.remap_indirectcommandslayoutnvxs(pPacket->indirectCommandsLayout);
            if (pPacket->indirectCommandsLayout != VK_NULL_HANDLE && remappedindirectCommandsLayout == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyIndirectCommandsLayoutNVX() due to invalid remapped VkIndirectCommandsLayoutNVX.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyIndirectCommandsLayoutNVX(remappeddevice, remappedindirectCommandsLayout, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateObjectTableNVX: { 
            packet_vkCreateObjectTableNVX* pPacket = (packet_vkCreateObjectTableNVX*)(packet->pBody);
            replayResult = manually_replay_vkCreateObjectTableNVX(pPacket);
            CHECK_RETURN_VALUE(vkCreateObjectTableNVX);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyObjectTableNVX: { 
            packet_vkDestroyObjectTableNVX* pPacket = (packet_vkDestroyObjectTableNVX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyObjectTableNVX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkObjectTableNVX remappedobjectTable = m_objMapper.remap_objecttablenvxs(pPacket->objectTable);
            if (pPacket->objectTable != VK_NULL_HANDLE && remappedobjectTable == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyObjectTableNVX() due to invalid remapped VkObjectTableNVX.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyObjectTableNVX(remappeddevice, remappedobjectTable, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkRegisterObjectsNVX: { 
            packet_vkRegisterObjectsNVX* pPacket = (packet_vkRegisterObjectsNVX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in RegisterObjectsNVX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkObjectTableNVX remappedobjectTable = m_objMapper.remap_objecttablenvxs(pPacket->objectTable);
            if (pPacket->objectTable != VK_NULL_HANDLE && remappedobjectTable == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in RegisterObjectsNVX() due to invalid remapped VkObjectTableNVX.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap objectCount
            // No need to remap ppObjectTableEntries
            // No need to remap pObjectIndices
            replayResult = m_vkDeviceFuncs.RegisterObjectsNVX(remappeddevice, remappedobjectTable, pPacket->objectCount, pPacket->ppObjectTableEntries, pPacket->pObjectIndices);
            CHECK_RETURN_VALUE(vkRegisterObjectsNVX);
            break;
        }
        case VKTRACE_TPI_VK_vkUnregisterObjectsNVX: { 
            packet_vkUnregisterObjectsNVX* pPacket = (packet_vkUnregisterObjectsNVX*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in UnregisterObjectsNVX() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkObjectTableNVX remappedobjectTable = m_objMapper.remap_objecttablenvxs(pPacket->objectTable);
            if (pPacket->objectTable != VK_NULL_HANDLE && remappedobjectTable == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in UnregisterObjectsNVX() due to invalid remapped VkObjectTableNVX.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap objectCount
            // No need to remap pObjectEntryTypes
            // No need to remap pObjectIndices
            replayResult = m_vkDeviceFuncs.UnregisterObjectsNVX(remappeddevice, remappedobjectTable, pPacket->objectCount, pPacket->pObjectEntryTypes, pPacket->pObjectIndices);
            CHECK_RETURN_VALUE(vkUnregisterObjectsNVX);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX: { 
            packet_vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX* pPacket = (packet_vkGetPhysicalDeviceGeneratedCommandsPropertiesNVX*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceGeneratedCommandsPropertiesNVX() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pFeatures
            // No need to remap pLimits
            m_vkFuncs.GetPhysicalDeviceGeneratedCommandsPropertiesNVX(remappedphysicalDevice, pPacket->pFeatures, pPacket->pLimits);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetViewportWScalingNV: { 
            packet_vkCmdSetViewportWScalingNV* pPacket = (packet_vkCmdSetViewportWScalingNV*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetViewportWScalingNV() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstViewport
            // No need to remap viewportCount
            // No need to remap pViewportWScalings
            m_vkDeviceFuncs.CmdSetViewportWScalingNV(remappedcommandBuffer, pPacket->firstViewport, pPacket->viewportCount, pPacket->pViewportWScalings);
            break;
        }
        case VKTRACE_TPI_VK_vkReleaseDisplayEXT: { 
            packet_vkReleaseDisplayEXT* pPacket = (packet_vkReleaseDisplayEXT*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ReleaseDisplayEXT() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDisplayKHR remappeddisplay = m_objMapper.remap_displaykhrs(pPacket->display);
            if (pPacket->display != VK_NULL_HANDLE && remappeddisplay == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in ReleaseDisplayEXT() due to invalid remapped VkDisplayKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            replayResult = m_vkFuncs.ReleaseDisplayEXT(remappedphysicalDevice, remappeddisplay);
            CHECK_RETURN_VALUE(vkReleaseDisplayEXT);
            break;
        }
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
        case VKTRACE_TPI_VK_vkAcquireXlibDisplayEXT: { 
            packet_vkAcquireXlibDisplayEXT* pPacket = (packet_vkAcquireXlibDisplayEXT*)(packet->pBody);
            VkDisplayKHR local_display;
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in AcquireXlibDisplayEXT() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dpy
            replayResult = m_vkFuncs.AcquireXlibDisplayEXT(remappedphysicalDevice, pPacket->dpy, &local_display);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_displaykhrs_map(*(pPacket->display), local_display);
            }
            CHECK_RETURN_VALUE(vkAcquireXlibDisplayEXT);
            break;
        }
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
        case VKTRACE_TPI_VK_vkGetRandROutputDisplayEXT: { 
            packet_vkGetRandROutputDisplayEXT* pPacket = (packet_vkGetRandROutputDisplayEXT*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetRandROutputDisplayEXT() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap dpy
            // No need to remap rrOutput
        VkDisplayKHR remappedpDisplay = m_objMapper.remap_pdisplays(*pPacket->pDisplay);
        if (pPacket->pDisplay != VK_NULL_HANDLE && remappedpDisplay == VK_NULL_HANDLE) {
            vktrace_LogError("Error detected in GetRandROutputDisplayEXT() due to invalid remapped VkDisplayKHR.");
            return vktrace_replay::VKTRACE_REPLAY_ERROR;
        }
            replayResult = m_vkFuncs.GetRandROutputDisplayEXT(remappedphysicalDevice, pPacket->dpy, pPacket->rrOutput, remappedpDisplay);
            CHECK_RETURN_VALUE(vkGetRandROutputDisplayEXT);
            break;
        }
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceSurfaceCapabilities2EXT: { 
            packet_vkGetPhysicalDeviceSurfaceCapabilities2EXT* pPacket = (packet_vkGetPhysicalDeviceSurfaceCapabilities2EXT*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceSurfaceCapabilities2EXT() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSurfaceKHR remappedsurface = m_objMapper.remap_surfacekhrs(pPacket->surface);
            if (pPacket->surface != VK_NULL_HANDLE && remappedsurface == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceSurfaceCapabilities2EXT() due to invalid remapped VkSurfaceKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSurfaceCapabilities
            replayResult = m_vkFuncs.GetPhysicalDeviceSurfaceCapabilities2EXT(remappedphysicalDevice, remappedsurface, pPacket->pSurfaceCapabilities);
            CHECK_RETURN_VALUE(vkGetPhysicalDeviceSurfaceCapabilities2EXT);
            break;
        }
        case VKTRACE_TPI_VK_vkDisplayPowerControlEXT: { 
            packet_vkDisplayPowerControlEXT* pPacket = (packet_vkDisplayPowerControlEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DisplayPowerControlEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkDisplayKHR remappeddisplay = m_objMapper.remap_displaykhrs(pPacket->display);
            if (pPacket->display != VK_NULL_HANDLE && remappeddisplay == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DisplayPowerControlEXT() due to invalid remapped VkDisplayKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pDisplayPowerInfo
            replayResult = m_vkDeviceFuncs.DisplayPowerControlEXT(remappeddevice, remappeddisplay, pPacket->pDisplayPowerInfo);
            CHECK_RETURN_VALUE(vkDisplayPowerControlEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkRegisterDeviceEventEXT: { 
            packet_vkRegisterDeviceEventEXT* pPacket = (packet_vkRegisterDeviceEventEXT*)(packet->pBody);
            replayResult = manually_replay_vkRegisterDeviceEventEXT(pPacket);
            CHECK_RETURN_VALUE(vkRegisterDeviceEventEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkRegisterDisplayEventEXT: { 
            packet_vkRegisterDisplayEventEXT* pPacket = (packet_vkRegisterDisplayEventEXT*)(packet->pBody);
            replayResult = manually_replay_vkRegisterDisplayEventEXT(pPacket);
            CHECK_RETURN_VALUE(vkRegisterDisplayEventEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkGetSwapchainCounterEXT: { 
            packet_vkGetSwapchainCounterEXT* pPacket = (packet_vkGetSwapchainCounterEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSwapchainCounterEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSwapchainKHR remappedswapchain = m_objMapper.remap_swapchainkhrs(pPacket->swapchain);
            if (pPacket->swapchain != VK_NULL_HANDLE && remappedswapchain == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetSwapchainCounterEXT() due to invalid remapped VkSwapchainKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap counter
            // No need to remap pCounterValue
            replayResult = m_vkDeviceFuncs.GetSwapchainCounterEXT(remappeddevice, remappedswapchain, pPacket->counter, pPacket->pCounterValue);
            CHECK_RETURN_VALUE(vkGetSwapchainCounterEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkGetRefreshCycleDurationGOOGLE: { 
            packet_vkGetRefreshCycleDurationGOOGLE* pPacket = (packet_vkGetRefreshCycleDurationGOOGLE*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetRefreshCycleDurationGOOGLE() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSwapchainKHR remappedswapchain = m_objMapper.remap_swapchainkhrs(pPacket->swapchain);
            if (pPacket->swapchain != VK_NULL_HANDLE && remappedswapchain == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetRefreshCycleDurationGOOGLE() due to invalid remapped VkSwapchainKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pDisplayTimingProperties
            replayResult = m_vkDeviceFuncs.GetRefreshCycleDurationGOOGLE(remappeddevice, remappedswapchain, pPacket->pDisplayTimingProperties);
            CHECK_RETURN_VALUE(vkGetRefreshCycleDurationGOOGLE);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPastPresentationTimingGOOGLE: { 
            packet_vkGetPastPresentationTimingGOOGLE* pPacket = (packet_vkGetPastPresentationTimingGOOGLE*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPastPresentationTimingGOOGLE() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkSwapchainKHR remappedswapchain = m_objMapper.remap_swapchainkhrs(pPacket->swapchain);
            if (pPacket->swapchain != VK_NULL_HANDLE && remappedswapchain == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPastPresentationTimingGOOGLE() due to invalid remapped VkSwapchainKHR.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pPresentationTimingCount
            // No need to remap pPresentationTimings
            replayResult = m_vkDeviceFuncs.GetPastPresentationTimingGOOGLE(remappeddevice, remappedswapchain, pPacket->pPresentationTimingCount, pPacket->pPresentationTimings);
            CHECK_RETURN_VALUE(vkGetPastPresentationTimingGOOGLE);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetDiscardRectangleEXT: { 
            packet_vkCmdSetDiscardRectangleEXT* pPacket = (packet_vkCmdSetDiscardRectangleEXT*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetDiscardRectangleEXT() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap firstDiscardRectangle
            // No need to remap discardRectangleCount
            // No need to remap pDiscardRectangles
            m_vkDeviceFuncs.CmdSetDiscardRectangleEXT(remappedcommandBuffer, pPacket->firstDiscardRectangle, pPacket->discardRectangleCount, pPacket->pDiscardRectangles);
            break;
        }
        case VKTRACE_TPI_VK_vkSetHdrMetadataEXT: { 
            packet_vkSetHdrMetadataEXT* pPacket = (packet_vkSetHdrMetadataEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in SetHdrMetadataEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap swapchainCount
            VkSwapchainKHR *remappedpSwapchains = new VkSwapchainKHR[pPacket->swapchainCount];
            for (uint32_t i = 0; i < pPacket->swapchainCount; i++) {
                remappedpSwapchains[i] = m_objMapper.remap_swapchainkhrs(pPacket->pSwapchains[i]);
                if (pPacket->pSwapchains[i] != VK_NULL_HANDLE && remappedpSwapchains[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in SetHdrMetadataEXT() due to invalid remapped VkSwapchainKHR.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            // No need to remap pMetadata
            m_vkDeviceFuncs.SetHdrMetadataEXT(remappeddevice, pPacket->swapchainCount, remappedpSwapchains, pPacket->pMetadata);
            break;
        }
        case VKTRACE_TPI_VK_vkCmdSetSampleLocationsEXT: { 
            packet_vkCmdSetSampleLocationsEXT* pPacket = (packet_vkCmdSetSampleLocationsEXT*)(packet->pBody);
            VkCommandBuffer remappedcommandBuffer = m_objMapper.remap_commandbuffers(pPacket->commandBuffer);
            if (pPacket->commandBuffer != VK_NULL_HANDLE && remappedcommandBuffer == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CmdSetSampleLocationsEXT() due to invalid remapped VkCommandBuffer.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pSampleLocationsInfo
            m_vkDeviceFuncs.CmdSetSampleLocationsEXT(remappedcommandBuffer, pPacket->pSampleLocationsInfo);
            break;
        }
        case VKTRACE_TPI_VK_vkGetPhysicalDeviceMultisamplePropertiesEXT: { 
            packet_vkGetPhysicalDeviceMultisamplePropertiesEXT* pPacket = (packet_vkGetPhysicalDeviceMultisamplePropertiesEXT*)(packet->pBody);
            VkPhysicalDevice remappedphysicalDevice = m_objMapper.remap_physicaldevices(pPacket->physicalDevice);
            if (pPacket->physicalDevice != VK_NULL_HANDLE && remappedphysicalDevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetPhysicalDeviceMultisamplePropertiesEXT() due to invalid remapped VkPhysicalDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap samples
            // No need to remap pMultisampleProperties
            m_vkFuncs.GetPhysicalDeviceMultisamplePropertiesEXT(remappedphysicalDevice, pPacket->samples, pPacket->pMultisampleProperties);
            break;
        }
        case VKTRACE_TPI_VK_vkCreateValidationCacheEXT: { 
            packet_vkCreateValidationCacheEXT* pPacket = (packet_vkCreateValidationCacheEXT*)(packet->pBody);
            VkValidationCacheEXT local_pValidationCache;
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in CreateValidationCacheEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pCreateInfo
            // No need to remap pAllocator
            replayResult = m_vkDeviceFuncs.CreateValidationCacheEXT(remappeddevice, pPacket->pCreateInfo, pPacket->pAllocator, &local_pValidationCache);
            if (replayResult == VK_SUCCESS) {
                m_objMapper.add_to_validationcacheexts_map(*(pPacket->pValidationCache), local_pValidationCache);
            }
            CHECK_RETURN_VALUE(vkCreateValidationCacheEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkDestroyValidationCacheEXT: { 
            packet_vkDestroyValidationCacheEXT* pPacket = (packet_vkDestroyValidationCacheEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyValidationCacheEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkValidationCacheEXT remappedvalidationCache = m_objMapper.remap_validationcacheexts(pPacket->validationCache);
            if (pPacket->validationCache != VK_NULL_HANDLE && remappedvalidationCache == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in DestroyValidationCacheEXT() due to invalid remapped VkValidationCacheEXT.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pAllocator
            m_vkDeviceFuncs.DestroyValidationCacheEXT(remappeddevice, remappedvalidationCache, pPacket->pAllocator);
            break;
        }
        case VKTRACE_TPI_VK_vkMergeValidationCachesEXT: { 
            packet_vkMergeValidationCachesEXT* pPacket = (packet_vkMergeValidationCachesEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in MergeValidationCachesEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkValidationCacheEXT remappeddstCache = m_objMapper.remap_validationcacheexts(pPacket->dstCache);
            if (pPacket->dstCache != VK_NULL_HANDLE && remappeddstCache == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in MergeValidationCachesEXT() due to invalid remapped VkValidationCacheEXT.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap srcCacheCount
            VkValidationCacheEXT *remappedpSrcCaches = new VkValidationCacheEXT[pPacket->srcCacheCount];
            for (uint32_t i = 0; i < pPacket->srcCacheCount; i++) {
                remappedpSrcCaches[i] = m_objMapper.remap_validationcacheexts(pPacket->pSrcCaches[i]);
                if (pPacket->pSrcCaches[i] != VK_NULL_HANDLE && remappedpSrcCaches[i] == VK_NULL_HANDLE) {
                    vktrace_LogError("Error detected in MergeValidationCachesEXT() due to invalid remapped VkValidationCacheEXT.");
                    return vktrace_replay::VKTRACE_REPLAY_ERROR;
                }
            }
            replayResult = m_vkDeviceFuncs.MergeValidationCachesEXT(remappeddevice, remappeddstCache, pPacket->srcCacheCount, remappedpSrcCaches);
            CHECK_RETURN_VALUE(vkMergeValidationCachesEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkGetValidationCacheDataEXT: { 
            packet_vkGetValidationCacheDataEXT* pPacket = (packet_vkGetValidationCacheDataEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetValidationCacheDataEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            VkValidationCacheEXT remappedvalidationCache = m_objMapper.remap_validationcacheexts(pPacket->validationCache);
            if (pPacket->validationCache != VK_NULL_HANDLE && remappedvalidationCache == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetValidationCacheDataEXT() due to invalid remapped VkValidationCacheEXT.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap pDataSize
            // No need to remap pData
            replayResult = m_vkDeviceFuncs.GetValidationCacheDataEXT(remappeddevice, remappedvalidationCache, pPacket->pDataSize, pPacket->pData);
            CHECK_RETURN_VALUE(vkGetValidationCacheDataEXT);
            break;
        }
        case VKTRACE_TPI_VK_vkGetMemoryHostPointerPropertiesEXT: { 
            packet_vkGetMemoryHostPointerPropertiesEXT* pPacket = (packet_vkGetMemoryHostPointerPropertiesEXT*)(packet->pBody);
            VkDevice remappeddevice = m_objMapper.remap_devices(pPacket->device);
            if (pPacket->device != VK_NULL_HANDLE && remappeddevice == VK_NULL_HANDLE) {
                vktrace_LogError("Error detected in GetMemoryHostPointerPropertiesEXT() due to invalid remapped VkDevice.");
                return vktrace_replay::VKTRACE_REPLAY_ERROR;
            }
            // No need to remap handleType
            // No need to remap pHostPointer
            // No need to remap pMemoryHostPointerProperties
            replayResult = m_vkDeviceFuncs.GetMemoryHostPointerPropertiesEXT(remappeddevice, pPacket->handleType, pPacket->pHostPointer, pPacket->pMemoryHostPointerProperties);
            CHECK_RETURN_VALUE(vkGetMemoryHostPointerPropertiesEXT);
            break;
        }
        default:
            vktrace_LogWarning("Unrecognized packet_id %u, skipping.", packet->packet_id);
            returnValue = vktrace_replay::VKTRACE_REPLAY_INVALID_ID;
            break;
    }
    return returnValue;
}
}
